" Vim syntax file
" Language:	TCL/TK
" Maintainer:	Brett Cannon <brett@python.org>
" 		(previously Dean Copsey <copsey@cs.ucdavis.edu>)
"		(previously Matt Neumann <mattneu@purpleturtle.com>)
"		(previously Allan Kelly <allan@fruitloaf.co.uk>)
" Original:	Robin Becker <robin@jessikat.demon.co.uk>
" Last Change:	2006 Nov 17
"
" Keywords TODO: format clock click anchor

" For version 5.x: Clear all syntax items
" For version 6.x: Quit when a syntax file was already loaded
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

" A bunch of useful keywords
syn keyword tclStatement  tell socket subst open eof pwd glob list exec pid
syn keyword tclStatement  auto_load_index time unknown eval lrange fblocked
syn keyword tclStatement  lsearch auto_import gets lappend proc variable llength
syn keyword tclStatement  auto_execok return linsert error catch clock info
syn keyword tclStatement  split array fconfigure concat join lreplace source
syn keyword tclStatement  fcopy global auto_qualify update close cd auto_load
syn keyword tclStatement  file append format read package set binary namespace
syn keyword tclStatement  scan trace seek flush after vwait uplevel lset rename
syn keyword tclStatement  fileevent regexp upvar unset encoding expr load regsub
syn keyword tclStatement interp exit puts incr lindex lsort tclLog string
syn keyword tclLabel		case default
syn keyword tclConditional	if then else elseif switch
syn keyword tclRepeat		while for foreach break continue
syn keyword tcltkSwitch	contained	insert create polygon fill outline tag

"######################ICC Commands Start ######################################
    syn keyword tclStatement _query_db
    syn keyword tclStatement add_clock_drivers
    syn keyword tclStatement add_distributed_hosts
    syn keyword tclStatement add_drc_error_detail
    syn keyword tclStatement add_end_cap
    syn keyword tclStatement add_open_drc_error_detail
    syn keyword tclStatement add_pg_pin_to_db
    syn keyword tclStatement add_pg_pin_to_lib
    syn keyword tclStatement add_port_state
    syn keyword tclStatement add_pst_state
    syn keyword tclStatement add_row
    syn keyword tclStatement add_tap_cell_array
    syn keyword tclStatement add_to_collection
    syn keyword tclStatement add_to_rp_group
    syn keyword tclStatement adjust_fp_floorplan
    syn keyword tclStatement adjust_fp_io_placement
    syn keyword tclStatement adjust_premesh_connection
    syn keyword tclStatement after
    syn keyword tclStatement alias
    syn keyword tclStatement align_fp_pins
    syn keyword tclStatement align_objects
    syn keyword tclStatement all_active_scenarios
    syn keyword tclStatement all_ao_cells
    syn keyword tclStatement all_bounds_of_cell
    syn keyword tclStatement all_cells_in_bound
    syn keyword tclStatement all_clocks
    syn keyword tclStatement all_connected
    syn keyword tclStatement all_connectivity_fanin
    syn keyword tclStatement all_connectivity_fanout
    syn keyword tclStatement all_critical_cells
    syn keyword tclStatement all_critical_pins
    syn keyword tclStatement all_designs
    syn keyword tclStatement all_dont_touch
    syn keyword tclStatement all_drc_violated_nets
    syn keyword tclStatement all_fanin
    syn keyword tclStatement all_fanout
    syn keyword tclStatement all_fixed_placement
    syn keyword tclStatement all_high_fanout
    syn keyword tclStatement all_ideal_nets
    syn keyword tclStatement all_inputs
    syn keyword tclStatement all_isolation_cells
    syn keyword tclStatement all_level_shifters
    syn keyword tclStatement all_macro_cells
    syn keyword tclStatement all_mtcmos_cells
    syn keyword tclStatement all_objects_in_bounding_box
    syn keyword tclStatement all_outputs
    syn keyword tclStatement all_physical_only_cells
    syn keyword tclStatement all_physical_only_nets
    syn keyword tclStatement all_physical_only_ports
    syn keyword tclStatement all_registers
    syn keyword tclStatement all_rp_groups
    syn keyword tclStatement all_rp_hierarchicals
    syn keyword tclStatement all_rp_inclusions
    syn keyword tclStatement all_rp_instantiations
    syn keyword tclStatement all_rp_references
    syn keyword tclStatement all_scenarios
    syn keyword tclStatement all_size_only_cells
    syn keyword tclStatement all_spare_cells
    syn keyword tclStatement all_threestate
    syn keyword tclStatement all_tieoff_cells
    syn keyword tclStatement allocate_fp_budgets
    syn keyword tclStatement analyze_fp_rail
    syn keyword tclStatement analyze_fp_routing
    syn keyword tclStatement analyze_rail
    syn keyword tclStatement analyze_subcircuit
    syn keyword tclStatement append
    syn keyword tclStatement append_to_collection
    syn keyword tclStatement apropos
    syn keyword tclStatement archive_design
    syn keyword tclStatement array
    syn keyword tclStatement assign_flip_chip_nets
    syn keyword tclStatement balance_inter_clock_delay
    syn keyword tclStatement binary
    syn keyword tclStatement break
    syn keyword tclStatement calculate_caa_based_yield2db
    syn keyword tclStatement calculate_hier_antenna_property
    syn keyword tclStatement catch
    syn keyword tclStatement cd
    syn keyword tclStatement change_fp_soft_macro_to_black_box
    syn keyword tclStatement change_link
    syn keyword tclStatement change_macro_view
    syn keyword tclStatement change_names
    syn keyword tclStatement change_selection
    syn keyword tclStatement change_selection_no_core
    syn keyword tclStatement change_selection_too_many_objects
    syn keyword tclStatement change_tie_connection
    syn keyword tclStatement characterize
    syn keyword tclStatement check_clock_tree
    syn keyword tclStatement check_database
    syn keyword tclStatement check_design
    syn keyword tclStatement check_error
    syn keyword tclStatement check_fp_budget_result
    syn keyword tclStatement check_fp_pin_alignment
    syn keyword tclStatement check_fp_pin_assignment
    syn keyword tclStatement check_fp_rail
    syn keyword tclStatement check_fp_timing_environment
    syn keyword tclStatement check_isolation_cells
    syn keyword tclStatement check_legality
    syn keyword tclStatement check_level_shifters
    syn keyword tclStatement check_library
    syn keyword tclStatement check_license
    syn keyword tclStatement check_mesh_net
    syn keyword tclStatement check_mpc
    syn keyword tclStatement check_mv_design
    syn keyword tclStatement check_noise
    syn keyword tclStatement check_physical_constraints
    syn keyword tclStatement check_physical_design
    syn keyword tclStatement check_route
    syn keyword tclStatement check_routeability
    syn keyword tclStatement check_rp_groups
    syn keyword tclStatement check_scan_chain
    syn keyword tclStatement check_scenarios
    syn keyword tclStatement check_target_library_subset
    syn keyword tclStatement check_timing
    syn keyword tclStatement check_tlu_plus_files
    syn keyword tclStatement clock
    syn keyword tclStatement clock_opt
    syn keyword tclStatement close
    syn keyword tclStatement close_distributed_route
    syn keyword tclStatement close_mw_cel
    syn keyword tclStatement close_mw_lib
    syn keyword tclStatement collection_to_list
    syn keyword tclStatement commit_fp_group_block_ring
    syn keyword tclStatement commit_fp_plan_groups
    syn keyword tclStatement commit_fp_rail
    syn keyword tclStatement commit_skew_group
    syn keyword tclStatement compare_collections
    syn keyword tclStatement compare_delay_calculation
    syn keyword tclStatement compare_interface_timing
    syn keyword tclStatement compare_lib
    syn keyword tclStatement compare_rc
    syn keyword tclStatement compile_clock_tree
    syn keyword tclStatement compile_fp_clock_plan
    syn keyword tclStatement compile_premesh_tree
    syn keyword tclStatement compute_polygons
    syn keyword tclStatement concat
    syn keyword tclStatement connect_net
    syn keyword tclStatement connect_pin
    syn keyword tclStatement connect_power_switch
    syn keyword tclStatement connect_spare_diode
    syn keyword tclStatement connect_supply_net
    syn keyword tclStatement connect_tie_cells
    syn keyword tclStatement continue
    syn keyword tclStatement convert_from_polygon
    syn keyword tclStatement convert_mw_lib
    syn keyword tclStatement convert_to_polygon
    syn keyword tclStatement convert_wire_ends
    syn keyword tclStatement convert_wire_to_pin
    syn keyword tclStatement copy_collection
    syn keyword tclStatement copy_floorplan
    syn keyword tclStatement copy_mim
    syn keyword tclStatement copy_mw_cel
    syn keyword tclStatement copy_mw_lib
    syn keyword tclStatement copy_objects
    syn keyword tclStatement count_drc_violations
    syn keyword tclStatement cputime
    syn keyword tclStatement create_auto_shield
    syn keyword tclStatement create_base_array
    syn keyword tclStatement create_boundary
    syn keyword tclStatement create_bounds
    syn keyword tclStatement create_buffer_tree
    syn keyword tclStatement create_cell
    syn keyword tclStatement create_clock
    syn keyword tclStatement create_clock_mesh
    syn keyword tclStatement create_command_group
    syn keyword tclStatement create_connview
    syn keyword tclStatement create_differential_group
    syn keyword tclStatement create_drc_error
    syn keyword tclStatement create_drc_error_type
    syn keyword tclStatement create_edit_group
    syn keyword tclStatement create_fp_block_shielding
    syn keyword tclStatement create_fp_blockages_for_child_hardmacro
    syn keyword tclStatement create_fp_group_block_ring
    syn keyword tclStatement create_fp_pins
    syn keyword tclStatement create_fp_placement
    syn keyword tclStatement create_fp_plan_group_padding
    syn keyword tclStatement create_fp_virtual_pad
    syn keyword tclStatement create_generated_clock
    syn keyword tclStatement create_ilm
    syn keyword tclStatement create_ilm_models
    syn keyword tclStatement create_lib_track
    syn keyword tclStatement create_macro_fram
    syn keyword tclStatement create_mw_cel
    syn keyword tclStatement create_mw_lib
    syn keyword tclStatement create_net
    syn keyword tclStatement create_net_shape
    syn keyword tclStatement create_open_drc_error
    syn keyword tclStatement create_open_locator_drc_error
    syn keyword tclStatement create_operating_conditions
    syn keyword tclStatement create_pad_rings
    syn keyword tclStatement create_partition
    syn keyword tclStatement create_pg_network
    syn keyword tclStatement create_physical_bus
    syn keyword tclStatement create_physical_buses_from_patterns
    syn keyword tclStatement create_pin_guide
    syn keyword tclStatement create_placement
    syn keyword tclStatement create_placement_blockage
    syn keyword tclStatement create_plan_groups
    syn keyword tclStatement create_port
    syn keyword tclStatement create_power_domain
    syn keyword tclStatement create_power_straps
    syn keyword tclStatement create_power_switch
    syn keyword tclStatement create_power_switch_array
    syn keyword tclStatement create_power_switch_ring
    syn keyword tclStatement create_preroute_vias
    syn keyword tclStatement create_pst
    syn keyword tclStatement create_qor_snapshot
    syn keyword tclStatement create_qtm_clock
    syn keyword tclStatement create_qtm_constraint_arc
    syn keyword tclStatement create_qtm_delay_arc
    syn keyword tclStatement create_qtm_drive_type
    syn keyword tclStatement create_qtm_generated_clock
    syn keyword tclStatement create_qtm_insertion_delay
    syn keyword tclStatement create_qtm_load_type
    syn keyword tclStatement create_qtm_model
    syn keyword tclStatement create_qtm_path_type
    syn keyword tclStatement create_qtm_port
    syn keyword tclStatement create_rail_setup
    syn keyword tclStatement create_rectangular_rings
    syn keyword tclStatement create_rectilinear_rings
    syn keyword tclStatement create_route_guide
    syn keyword tclStatement create_routing_blockage
    syn keyword tclStatement create_rp_group
    syn keyword tclStatement create_scenario
    syn keyword tclStatement create_short_drc_error
    syn keyword tclStatement create_site_row
    syn keyword tclStatement create_spacing_drc_error
    syn keyword tclStatement create_stack_via_on_pad_pin
    syn keyword tclStatement create_supply_net
    syn keyword tclStatement create_supply_port
    syn keyword tclStatement create_terminal
    syn keyword tclStatement create_text
    syn keyword tclStatement create_track
    syn keyword tclStatement create_user_shape
    syn keyword tclStatement create_via
    syn keyword tclStatement create_voltage_area
    syn keyword tclStatement create_zrt_shield
    syn keyword tclStatement current_design
    syn keyword tclStatement current_design_name
    syn keyword tclStatement current_instance
    syn keyword tclStatement current_mw_cel
    syn keyword tclStatement current_mw_lib
    syn keyword tclStatement current_scenario
    syn keyword tclStatement cut_objects
    syn keyword tclStatement cut_row
    syn keyword tclStatement date
    syn keyword tclStatement decrypt_lib
    syn keyword tclStatement define_antenna_accumulation_mode
    syn keyword tclStatement define_antenna_area_rule
    syn keyword tclStatement define_antenna_layer_ratio_scale
    syn keyword tclStatement define_antenna_layer_rule
    syn keyword tclStatement define_antenna_rule
    syn keyword tclStatement define_bus
    syn keyword tclStatement define_io_antenna_area
    syn keyword tclStatement define_io_diode_protection
    syn keyword tclStatement define_io_gate_size
    syn keyword tclStatement define_name_rules
    syn keyword tclStatement define_proc_attributes
    syn keyword tclStatement define_routing_rule
    syn keyword tclStatement define_scaling_lib_group
    syn keyword tclStatement define_user_attribute
    syn keyword tclStatement define_via
    syn keyword tclStatement define_zrt_redundant_vias
    syn keyword tclStatement delete_operating_conditions
    syn keyword tclStatement derive_constraints
    syn keyword tclStatement derive_mpc_macro_options
    syn keyword tclStatement derive_mpc_options
    syn keyword tclStatement derive_mpc_port_options
    syn keyword tclStatement derive_pg_connection
    syn keyword tclStatement detect_flcc_hotspot
    syn keyword tclStatement detect_lcc_hotspot
    syn keyword tclStatement disconnect_net
    syn keyword tclStatement display_flip_chip_route_flylines
    syn keyword tclStatement distribute_objects
    syn keyword tclStatement drive_of
    syn keyword tclStatement echo
    syn keyword tclStatement eco_netlist
    syn keyword tclStatement encoding
    syn keyword tclStatement end_fp_trace_mode
    syn keyword tclStatement eof
    syn keyword tclStatement error
    syn keyword tclStatement error_info
    syn keyword tclStatement estimate_fp_area
    syn keyword tclStatement estimate_fp_black_boxes
    syn keyword tclStatement estimate_rc
    syn keyword tclStatement eval
    syn keyword tclStatement exec
    syn keyword tclStatement exit
    syn keyword tclStatement expand_flip_chip_cell_locations
    syn keyword tclStatement expand_objects
    syn keyword tclStatement explore_power_switch
    syn keyword tclStatement expr
    syn keyword tclStatement extract_blockage_pin_via
    syn keyword tclStatement extract_flcc_hotspot
    syn keyword tclStatement extract_fp_rail_to_constraints
    syn keyword tclStatement extract_fp_relative_location
    syn keyword tclStatement extract_hier_antenna_property
    syn keyword tclStatement extract_rc
    syn keyword tclStatement extract_rp_group
    syn keyword tclStatement extract_zrt_hier_antenna_property
    syn keyword tclStatement fblocked
    syn keyword tclStatement fconfigure
    syn keyword tclStatement fcopy
    syn keyword tclStatement file
    syn keyword tclStatement fileevent
    syn keyword tclStatement filter_collection
    syn keyword tclStatement fix_flcc_hotspot
    syn keyword tclStatement fix_isolated_via
    syn keyword tclStatement fix_lcc_hotspot
    syn keyword tclStatement flatten_clock_gating
    syn keyword tclStatement flatten_fp_black_boxes
    syn keyword tclStatement flatten_fp_hierarchy
    syn keyword tclStatement flip_mim
    syn keyword tclStatement flip_objects
    syn keyword tclStatement flush
    syn keyword tclStatement focal_opt
    syn keyword tclStatement for
    syn keyword tclStatement foreach
    syn keyword tclStatement foreach_in_collection
    syn keyword tclStatement format
    syn keyword tclStatement generate_qtm_model
    syn keyword tclStatement get_adjusted_endpoints
    syn keyword tclStatement get_alternative_lib_cells
    syn keyword tclStatement get_always_on_logic
    syn keyword tclStatement get_app_var
    syn keyword tclStatement get_attribute
    syn keyword tclStatement get_bounds
    syn keyword tclStatement get_buffers
    syn keyword tclStatement get_cell_sites
    syn keyword tclStatement get_cells
    syn keyword tclStatement get_clocks
    syn keyword tclStatement get_command_option_values
    syn keyword tclStatement get_core_area
    syn keyword tclStatement get_coupling_capacitors
    syn keyword tclStatement get_cts_scenario
    syn keyword tclStatement get_design_lib_path
    syn keyword tclStatement get_designs
    syn keyword tclStatement get_die_area
    syn keyword tclStatement get_dominant_scenarios
    syn keyword tclStatement get_drc_errors
    syn keyword tclStatement get_edit_groups
    syn keyword tclStatement get_error_view_property
    syn keyword tclStatement get_flat_cells
    syn keyword tclStatement get_flat_nets
    syn keyword tclStatement get_flat_pins
    syn keyword tclStatement get_floorplan_data
    syn keyword tclStatement get_fp_trace_mode
    syn keyword tclStatement get_fp_wirelength
    syn keyword tclStatement get_generated_clocks
    syn keyword tclStatement get_ilm_objects
    syn keyword tclStatement get_ilms
    syn keyword tclStatement get_layer_attribute
    syn keyword tclStatement get_layers
    syn keyword tclStatement get_lib_attribute
    syn keyword tclStatement get_lib_cells
    syn keyword tclStatement get_lib_pins
    syn keyword tclStatement get_libs
    syn keyword tclStatement get_license
    syn keyword tclStatement get_location
    syn keyword tclStatement get_magnet_cells
    syn keyword tclStatement get_mesh_nets
    syn keyword tclStatement get_message_info
    syn keyword tclStatement get_mw_cels
    syn keyword tclStatement get_net_shapes
    syn keyword tclStatement get_nets
    syn keyword tclStatement get_new_bounds
    syn keyword tclStatement get_object_fixed_edit
    syn keyword tclStatement get_object_name
    syn keyword tclStatement get_object_snap_type
    syn keyword tclStatement get_path_groups
    syn keyword tclStatement get_physical_buses
    syn keyword tclStatement get_physical_lib_cells
    syn keyword tclStatement get_physical_lib_pins
    syn keyword tclStatement get_physical_libs
    syn keyword tclStatement get_pin_guides
    syn keyword tclStatement get_pin_shapes
    syn keyword tclStatement get_pins
    syn keyword tclStatement get_placement_area
    syn keyword tclStatement get_placement_blockages
    syn keyword tclStatement get_plan_groups
    syn keyword tclStatement get_polygon_area
    syn keyword tclStatement get_ports
    syn keyword tclStatement get_power_domains
    syn keyword tclStatement get_power_switches
    syn keyword tclStatement get_route_guides
    syn keyword tclStatement get_route_mode_options
    syn keyword tclStatement get_route_zrt_common_options
    syn keyword tclStatement get_route_zrt_detail_options
    syn keyword tclStatement get_route_zrt_global_options
    syn keyword tclStatement get_route_zrt_track_options
    syn keyword tclStatement get_routing_blockages
    syn keyword tclStatement get_rp_group_keepouts
    syn keyword tclStatement get_rp_groups
    syn keyword tclStatement get_scan_cells_of_chain
    syn keyword tclStatement get_scan_chains
    syn keyword tclStatement get_selection
    syn keyword tclStatement get_si_xtalk_bumps
    syn keyword tclStatement get_site_rows
    syn keyword tclStatement get_supply_nets
    syn keyword tclStatement get_supply_ports
    syn keyword tclStatement get_terminals
    syn keyword tclStatement get_text
    syn keyword tclStatement get_timing_paths
    syn keyword tclStatement get_tracks
    syn keyword tclStatement get_unix_variable
    syn keyword tclStatement get_user_grid
    syn keyword tclStatement get_user_shapes
    syn keyword tclStatement get_via_masters
    syn keyword tclStatement get_vias
    syn keyword tclStatement get_voltage_areas
    syn keyword tclStatement get_zero_interconnect_delay_mode
    syn keyword tclStatement get_zrt_net_properties
    syn keyword tclStatement getenv
    syn keyword tclStatement gets
    syn keyword tclStatement glob
    syn keyword tclStatement global
    syn keyword tclStatement group
    syn keyword tclStatement group_path
    syn keyword tclStatement gui_bin
    syn keyword tclStatement gui_change_highlight
    syn keyword tclStatement gui_create_attrdef
    syn keyword tclStatement gui_create_attrgroup
    syn keyword tclStatement gui_create_pref_category
    syn keyword tclStatement gui_create_pref_key
    syn keyword tclStatement gui_create_vm
    syn keyword tclStatement gui_create_vm_objects
    syn keyword tclStatement gui_create_vmbucket
    syn keyword tclStatement gui_delete_attrdef
    syn keyword tclStatement gui_delete_attrgroup
    syn keyword tclStatement gui_edit_vmbucket_contents
    syn keyword tclStatement gui_exist_pref_category
    syn keyword tclStatement gui_exist_pref_key
    syn keyword tclStatement gui_get_current_task
    syn keyword tclStatement gui_get_highlight
    syn keyword tclStatement gui_get_highlight_options
    syn keyword tclStatement gui_get_pref_keys
    syn keyword tclStatement gui_get_pref_value
    syn keyword tclStatement gui_get_routes_between_objects
    syn keyword tclStatement gui_get_setting
    syn keyword tclStatement gui_get_task_list
    syn keyword tclStatement gui_get_vm
    syn keyword tclStatement gui_get_vmbucket
    syn keyword tclStatement gui_get_window_ids
    syn keyword tclStatement gui_get_window_pref_categories
    syn keyword tclStatement gui_get_window_pref_keys
    syn keyword tclStatement gui_get_window_pref_value
    syn keyword tclStatement gui_get_window_types
    syn keyword tclStatement gui_list_attrdefs
    syn keyword tclStatement gui_list_attrgroups
    syn keyword tclStatement gui_list_vm
    syn keyword tclStatement gui_load_cell_density_mm
    syn keyword tclStatement gui_load_pin_density_mm
    syn keyword tclStatement gui_remove_pref_key
    syn keyword tclStatement gui_remove_vm
    syn keyword tclStatement gui_remove_vmbucket
    syn keyword tclStatement gui_set_current_task
    syn keyword tclStatement gui_set_highlight_options
    syn keyword tclStatement gui_set_pref_value
    syn keyword tclStatement gui_set_setting
    syn keyword tclStatement gui_set_vm
    syn keyword tclStatement gui_set_vmbucket
    syn keyword tclStatement gui_set_window_pref_key
    syn keyword tclStatement gui_show_man_page
    syn keyword tclStatement gui_start
    syn keyword tclStatement gui_stop
    syn keyword tclStatement gui_update_attrdef
    syn keyword tclStatement gui_update_attrgroup
    syn keyword tclStatement gui_update_pref_file
    syn keyword tclStatement gui_update_vm
    syn keyword tclStatement gui_update_vm_annotations
    syn keyword tclStatement help
    syn keyword tclStatement history
    syn keyword tclStatement hookup_retention_register
    syn keyword tclStatement hookup_testports
    syn keyword tclStatement identify_clock_gating
    syn keyword tclStatement if
    syn keyword tclStatement ignore_site_row
    syn keyword tclStatement import_designs
    syn keyword tclStatement import_fp_black_boxes
    syn keyword tclStatement incr
    syn keyword tclStatement index_collection
    syn keyword tclStatement info
    syn keyword tclStatement initialize_floorplan
    syn keyword tclStatement initialize_rectilinear_block
    syn keyword tclStatement insert_buffer
    syn keyword tclStatement insert_diode
    syn keyword tclStatement insert_isolation_cell
    syn keyword tclStatement insert_level_shifters
    syn keyword tclStatement insert_metal_filler
    syn keyword tclStatement insert_ng_filler
    syn keyword tclStatement insert_pad_filler
    syn keyword tclStatement insert_port_protection_diodes
    syn keyword tclStatement insert_redundant_vias
    syn keyword tclStatement insert_spare_cells
    syn keyword tclStatement insert_stdcell_filler
    syn keyword tclStatement insert_tap_cells_by_rules
    syn keyword tclStatement insert_well_filler
    syn keyword tclStatement insert_zrt_redundant_vias
    syn keyword tclStatement interp
    syn keyword tclStatement is_false
    syn keyword tclStatement is_true
    syn keyword tclStatement is_zrt_routed_design
    syn keyword tclStatement join
    syn keyword tclStatement lappend
    syn keyword tclStatement legalize_fp_placement
    syn keyword tclStatement legalize_placement
    syn keyword tclStatement lib2saif
    syn keyword tclStatement license_users
    syn keyword tclStatement lindex
    syn keyword tclStatement link
    syn keyword tclStatement link_physical_library
    syn keyword tclStatement linsert
    syn keyword tclStatement list
    syn keyword tclStatement list_attributes
    syn keyword tclStatement list_designs
    syn keyword tclStatement list_drc_error_types
    syn keyword tclStatement list_files
    syn keyword tclStatement list_floorplan_data
    syn keyword tclStatement list_instances
    syn keyword tclStatement list_libs
    syn keyword tclStatement list_licenses
    syn keyword tclStatement list_mw_cels
    syn keyword tclStatement list_partition_data
    syn keyword tclStatement llength
    syn keyword tclStatement lminus
    syn keyword tclStatement load_fp_rail_map
    syn keyword tclStatement load_of
    syn keyword tclStatement load_upf
    syn keyword tclStatement lrange
    syn keyword tclStatement lreplace
    syn keyword tclStatement ls
    syn keyword tclStatement lsearch
    syn keyword tclStatement lset
    syn keyword tclStatement lsort
    syn keyword tclStatement magnet_placement
    syn keyword tclStatement man
    syn keyword tclStatement map_freeze_silicon
    syn keyword tclStatement map_isolation_cell
    syn keyword tclStatement map_level_shifter_cell
    syn keyword tclStatement map_power_switch
    syn keyword tclStatement map_retention_cell
    syn keyword tclStatement mark_clock_tree
    syn keyword tclStatement mem
    syn keyword tclStatement merge_clock_gates
    syn keyword tclStatement merge_flip_chip_nets
    syn keyword tclStatement merge_fp_hierarchy
    syn keyword tclStatement merge_net_shapes
    syn keyword tclStatement merge_saif
    syn keyword tclStatement move_mw_cel_origin
    syn keyword tclStatement move_objects
    syn keyword tclStatement move_pins_on_edge
    syn keyword tclStatement name_format
    syn keyword tclStatement namespace
    syn keyword tclStatement open
    syn keyword tclStatement open_mw_cel
    syn keyword tclStatement open_mw_lib
    syn keyword tclStatement optimize_clock_tree
    syn keyword tclStatement optimize_dft
    syn keyword tclStatement optimize_flip_chip_route
    syn keyword tclStatement optimize_fp_timing
    syn keyword tclStatement optimize_netlist_hierarchy
    syn keyword tclStatement optimize_power_switch
    syn keyword tclStatement optimize_pre_cts_power
    syn keyword tclStatement optimize_wire_via
    syn keyword tclStatement order_rp_groups
    syn keyword tclStatement pack_fp_macro_in_area
    syn keyword tclStatement package
    syn keyword tclStatement parse_proc_arguments
    syn keyword tclStatement pid
    syn keyword tclStatement place_flip_chip_array
    syn keyword tclStatement place_flip_chip_ring
    syn keyword tclStatement place_fp_pins
    syn keyword tclStatement place_freeze_silicon
    syn keyword tclStatement place_io_pads
    syn keyword tclStatement place_opt
    syn keyword tclStatement place_opt_feasibility
    syn keyword tclStatement preroute_instances
    syn keyword tclStatement preroute_standard_cells
    syn keyword tclStatement print_message_info
    syn keyword tclStatement print_proc_new_vars
    syn keyword tclStatement print_suppressed_messages
    syn keyword tclStatement printenv
    syn keyword tclStatement printvar
    syn keyword tclStatement proc
    syn keyword tclStatement proc_args
    syn keyword tclStatement proc_body
    syn keyword tclStatement process_particle_probability_file
    syn keyword tclStatement propagate_constraints
    syn keyword tclStatement propagate_ilm
    syn keyword tclStatement propagate_switching_activity
    syn keyword tclStatement psynopt
    syn keyword tclStatement push_down_fp_objects
    syn keyword tclStatement push_flip_chip_route
    syn keyword tclStatement push_up_fp_objects
    syn keyword tclStatement puts
    syn keyword tclStatement pwd
    syn keyword tclStatement query_objects
    syn keyword tclStatement quit
    syn keyword tclStatement quit!
    syn keyword tclStatement read
    syn keyword tclStatement read_antenna_violation
    syn keyword tclStatement read_aocvm
    syn keyword tclStatement read_ddc
    syn keyword tclStatement read_def
    syn keyword tclStatement read_drc_error_file
    syn keyword tclStatement read_file
    syn keyword tclStatement read_flip_chip_bumps
    syn keyword tclStatement read_floorplan
    syn keyword tclStatement read_io_constraints
    syn keyword tclStatement read_lib
    syn keyword tclStatement read_mw_eco_list
    syn keyword tclStatement read_parasitics
    syn keyword tclStatement read_partition
    syn keyword tclStatement read_rail_maps
    syn keyword tclStatement read_saif
    syn keyword tclStatement read_sdc
    syn keyword tclStatement read_sdf
    syn keyword tclStatement read_tdf_ports
    syn keyword tclStatement read_verilog
    syn keyword tclStatement read_zrt_route_guidance
    syn keyword tclStatement rebuild_mw_lib
    syn keyword tclStatement recompute_fit_bbox
    syn keyword tclStatement recover_tie_connection
    syn keyword tclStatement redirect
    syn keyword tclStatement redo
    syn keyword tclStatement reduce_fp_rail_stacked_via
    syn keyword tclStatement refine_fp_macro_channels
    syn keyword tclStatement refine_placement
    syn keyword tclStatement regexp
    syn keyword tclStatement regsub
    syn keyword tclStatement remove_all_spacing_rules
    syn keyword tclStatement remove_annotated_check
    syn keyword tclStatement remove_annotated_delay
    syn keyword tclStatement remove_annotated_transition
    syn keyword tclStatement remove_annotations
    syn keyword tclStatement remove_antenna_rules
    syn keyword tclStatement remove_aocvm
    syn keyword tclStatement remove_attribute
    syn keyword tclStatement remove_base_arrays
    syn keyword tclStatement remove_bounds
    syn keyword tclStatement remove_buffer
    syn keyword tclStatement remove_buffer_tree
    syn keyword tclStatement remove_bus
    syn keyword tclStatement remove_case_analysis
    syn keyword tclStatement remove_cell
    syn keyword tclStatement remove_cell_degradation
    syn keyword tclStatement remove_cell_sites
    syn keyword tclStatement remove_cell_vt_type
    syn keyword tclStatement remove_checkpoint_designs
    syn keyword tclStatement remove_clock
    syn keyword tclStatement remove_clock_gates
    syn keyword tclStatement remove_clock_gating_check
    syn keyword tclStatement remove_clock_groups
    syn keyword tclStatement remove_clock_latency
    syn keyword tclStatement remove_clock_mesh
    syn keyword tclStatement remove_clock_sense
    syn keyword tclStatement remove_clock_transition
    syn keyword tclStatement remove_clock_tree
    syn keyword tclStatement remove_clock_tree_exceptions
    syn keyword tclStatement remove_clock_tree_options
    syn keyword tclStatement remove_clock_uncertainty
    syn keyword tclStatement remove_congestion_options
    syn keyword tclStatement remove_cts_scenario
    syn keyword tclStatement remove_dangling_wires
    syn keyword tclStatement remove_data_check
    syn keyword tclStatement remove_design
    syn keyword tclStatement remove_diode
    syn keyword tclStatement remove_disable_clock_gating_check
    syn keyword tclStatement remove_disable_timing
    syn keyword tclStatement remove_distributed_hosts
    syn keyword tclStatement remove_distributed_route
    syn keyword tclStatement remove_dont_touch_placement
    syn keyword tclStatement remove_dp_int_round
    syn keyword tclStatement remove_drc_error
    syn keyword tclStatement remove_driving_cell
    syn keyword tclStatement remove_edit_groups
    syn keyword tclStatement remove_fanout_load
    syn keyword tclStatement remove_filler_with_violation
    syn keyword tclStatement remove_flip_chip_route
    syn keyword tclStatement remove_fp_block_shielding
    syn keyword tclStatement remove_fp_feedthroughs
    syn keyword tclStatement remove_fp_pin_constraints
    syn keyword tclStatement remove_fp_pin_overlaps
    syn keyword tclStatement remove_fp_plan_group_padding
    syn keyword tclStatement remove_fp_rail_stacked_via
    syn keyword tclStatement remove_fp_rail_voltage_area_constraints
    syn keyword tclStatement remove_fp_relative_location
    syn keyword tclStatement remove_fp_virtual_pad
    syn keyword tclStatement remove_fp_voltage_area_constraints
    syn keyword tclStatement remove_from_collection
    syn keyword tclStatement remove_from_rp_group
    syn keyword tclStatement remove_generated_clock
    syn keyword tclStatement remove_host_options
    syn keyword tclStatement remove_ideal_latency
    syn keyword tclStatement remove_ideal_net
    syn keyword tclStatement remove_ideal_network
    syn keyword tclStatement remove_ideal_transition
    syn keyword tclStatement remove_ignore_cell_timing
    syn keyword tclStatement remove_ignored_layers
    syn keyword tclStatement remove_input_delay
    syn keyword tclStatement remove_io_antenna_properties
    syn keyword tclStatement remove_io_constraints
    syn keyword tclStatement remove_io_pin_overlap
    syn keyword tclStatement remove_isolate_ports
    syn keyword tclStatement remove_isolation_cell
    syn keyword tclStatement remove_keepout_margin
    syn keyword tclStatement remove_left_right_filler_rule
    syn keyword tclStatement remove_level_shifters
    syn keyword tclStatement remove_license
    syn keyword tclStatement remove_map_power_switch
    syn keyword tclStatement remove_mim_property
    syn keyword tclStatement remove_mw_cel
    syn keyword tclStatement remove_net
    syn keyword tclStatement remove_net_routing
    syn keyword tclStatement remove_net_routing_layer_constraints
    syn keyword tclStatement remove_net_shape
    syn keyword tclStatement remove_net_timing_spacing
    syn keyword tclStatement remove_objects
    syn keyword tclStatement remove_output_delay
    syn keyword tclStatement remove_partition
    syn keyword tclStatement remove_pg_network
    syn keyword tclStatement remove_physical_bus
    syn keyword tclStatement remove_pin_guides
    syn keyword tclStatement remove_pin_name_synonym
    syn keyword tclStatement remove_placement
    syn keyword tclStatement remove_placement_blockage
    syn keyword tclStatement remove_plan_groups
    syn keyword tclStatement remove_pnet_options
    syn keyword tclStatement remove_port
    syn keyword tclStatement remove_power_domain
    syn keyword tclStatement remove_power_switch
    syn keyword tclStatement remove_preferred_routing_direction
    syn keyword tclStatement remove_propagated_clock
    syn keyword tclStatement remove_qor_snapshot
    syn keyword tclStatement remove_rail_maps
    syn keyword tclStatement remove_route_by_type
    syn keyword tclStatement remove_route_guide
    syn keyword tclStatement remove_routing_blockage
    syn keyword tclStatement remove_routing_rules
    syn keyword tclStatement remove_row_type
    syn keyword tclStatement remove_rp_group_options
    syn keyword tclStatement remove_rp_groups
    syn keyword tclStatement remove_scaling_lib_group
    syn keyword tclStatement remove_scan_def
    syn keyword tclStatement remove_scan_pin_type
    syn keyword tclStatement remove_scenario
    syn keyword tclStatement remove_sdc
    syn keyword tclStatement remove_site_row
    syn keyword tclStatement remove_skew_group
    syn keyword tclStatement remove_stdcell_filler
    syn keyword tclStatement remove_supply_net
    syn keyword tclStatement remove_supply_port
    syn keyword tclStatement remove_target_library_subset
    syn keyword tclStatement remove_terminal
    syn keyword tclStatement remove_text
    syn keyword tclStatement remove_tie_cells
    syn keyword tclStatement remove_track
    syn keyword tclStatement remove_unconnected_ports
    syn keyword tclStatement remove_user_shape
    syn keyword tclStatement remove_via
    syn keyword tclStatement remove_voltage_area
    syn keyword tclStatement remove_vt_filler_rule
    syn keyword tclStatement remove_well_filler
    syn keyword tclStatement remove_xtalk_prop
    syn keyword tclStatement remove_zrt_filler_with_violation
    syn keyword tclStatement remove_zrt_redundant_shapes
    syn keyword tclStatement rename
    syn keyword tclStatement rename_mw_cel
    syn keyword tclStatement rename_mw_lib
    syn keyword tclStatement replace_power_switch
    syn keyword tclStatement report_adjusted_endpoints
    syn keyword tclStatement report_ahfs_options
    syn keyword tclStatement report_annotated_check
    syn keyword tclStatement report_annotated_delay
    syn keyword tclStatement report_annotated_transition
    syn keyword tclStatement report_antenna_ratio
    syn keyword tclStatement report_antenna_rules
    syn keyword tclStatement report_aocvm
    syn keyword tclStatement report_app_var
    syn keyword tclStatement report_area
    syn keyword tclStatement report_area_recovery_options
    syn keyword tclStatement report_attribute
    syn keyword tclStatement report_bounds
    syn keyword tclStatement report_buffer_tree
    syn keyword tclStatement report_buffer_tree_qor
    syn keyword tclStatement report_bus
    syn keyword tclStatement report_case_analysis
    syn keyword tclStatement report_cbt_options
    syn keyword tclStatement report_cell
    syn keyword tclStatement report_cell_physical
    syn keyword tclStatement report_cell_vt_type
    syn keyword tclStatement report_change_list
    syn keyword tclStatement report_check_library_options
    syn keyword tclStatement report_checkpoint_designs
    syn keyword tclStatement report_clock
    syn keyword tclStatement report_clock_gating
    syn keyword tclStatement report_clock_gating_check
    syn keyword tclStatement report_clock_timing
    syn keyword tclStatement report_clock_tree
    syn keyword tclStatement report_clock_tree_optimization_options
    syn keyword tclStatement report_clock_tree_power
    syn keyword tclStatement report_congestion
    syn keyword tclStatement report_congestion_options
    syn keyword tclStatement report_constraint
    syn keyword tclStatement report_critical_area
    syn keyword tclStatement report_crpr
    syn keyword tclStatement report_cts_batch_mode
    syn keyword tclStatement report_delay_calculation
    syn keyword tclStatement report_delay_estimation_options
    syn keyword tclStatement report_design
    syn keyword tclStatement report_design_lib
    syn keyword tclStatement report_design_physical
    syn keyword tclStatement report_direct_power_rail_tie
    syn keyword tclStatement report_disable_timing
    syn keyword tclStatement report_distributed_hosts
    syn keyword tclStatement report_distributed_route
    syn keyword tclStatement report_drc_error_type
    syn keyword tclStatement report_droute_options
    syn keyword tclStatement report_eco_history
    syn keyword tclStatement report_edit_groups
    syn keyword tclStatement report_error_coordinates
    syn keyword tclStatement report_extraction_options
    syn keyword tclStatement report_fast_mode
    syn keyword tclStatement report_feasibility_options
    syn keyword tclStatement report_filler_placement
    syn keyword tclStatement report_flip_chip_bump_attributes
    syn keyword tclStatement report_flip_chip_driver_bump
    syn keyword tclStatement report_flip_chip_type
    syn keyword tclStatement report_floorplan_data
    syn keyword tclStatement report_fp_clock_plan_options
    syn keyword tclStatement report_fp_macro_array
    syn keyword tclStatement report_fp_macro_options
    syn keyword tclStatement report_fp_pin_constraints
    syn keyword tclStatement report_fp_placement
    syn keyword tclStatement report_fp_placement_strategy
    syn keyword tclStatement report_fp_rail_constraints
    syn keyword tclStatement report_fp_rail_strategy
    syn keyword tclStatement report_fp_rail_voltage_area_constraints
    syn keyword tclStatement report_fp_relative_location
    syn keyword tclStatement report_fp_shaping_strategy
    syn keyword tclStatement report_fp_voltage_area_constraints
    syn keyword tclStatement report_groute_options
    syn keyword tclStatement report_hierarchy
    syn keyword tclStatement report_host_options
    syn keyword tclStatement report_ideal_network
    syn keyword tclStatement report_ignored_layers
    syn keyword tclStatement report_ilm
    syn keyword tclStatement report_interclock_relation
    syn keyword tclStatement report_internal_loads
    syn keyword tclStatement report_io_antenna_properties
    syn keyword tclStatement report_io_constraints
    syn keyword tclStatement report_isolate_ports
    syn keyword tclStatement report_isolated_via
    syn keyword tclStatement report_isolation_cell
    syn keyword tclStatement report_keepout_margin
    syn keyword tclStatement report_latency_adjustment_options
    syn keyword tclStatement report_lcc_hotspot
    syn keyword tclStatement report_left_right_filler_rule
    syn keyword tclStatement report_level_shifter
    syn keyword tclStatement report_lib
    syn keyword tclStatement report_milkyway_version
    syn keyword tclStatement report_mim
    syn keyword tclStatement report_mode
    syn keyword tclStatement report_mpc_macro_array
    syn keyword tclStatement report_mpc_macro_options
    syn keyword tclStatement report_mpc_options
    syn keyword tclStatement report_mpc_pnet_options
    syn keyword tclStatement report_mpc_port_options
    syn keyword tclStatement report_mpc_rectilinear_outline
    syn keyword tclStatement report_mpc_ring_options
    syn keyword tclStatement report_mtcmos_pna_strategy
    syn keyword tclStatement report_mw_design_ecos
    syn keyword tclStatement report_mw_lib
    syn keyword tclStatement report_name_rules
    syn keyword tclStatement report_names
    syn keyword tclStatement report_net
    syn keyword tclStatement report_net_changes
    syn keyword tclStatement report_net_characteristics
    syn keyword tclStatement report_net_delta_delay
    syn keyword tclStatement report_net_fanout
    syn keyword tclStatement report_net_routing_layer_constraints
    syn keyword tclStatement report_net_routing_rules
    syn keyword tclStatement report_noise
    syn keyword tclStatement report_noise_calculation
    syn keyword tclStatement report_operating_conditions
    syn keyword tclStatement report_optimize_dft_options
    syn keyword tclStatement report_optimize_pre_cts_power_options
    syn keyword tclStatement report_parameter
    syn keyword tclStatement report_path_group
    syn keyword tclStatement report_pg_net
    syn keyword tclStatement report_physical_bus
    syn keyword tclStatement report_physical_signoff_options
    syn keyword tclStatement report_pin_guides
    syn keyword tclStatement report_pin_name_synonym
    syn keyword tclStatement report_pin_shape
    syn keyword tclStatement report_placement_utilization
    syn keyword tclStatement report_pnet_options
    syn keyword tclStatement report_port
    syn keyword tclStatement report_port_protection_diodes
    syn keyword tclStatement report_power
    syn keyword tclStatement report_power_calculation
    syn keyword tclStatement report_power_domain
    syn keyword tclStatement report_power_gating
    syn keyword tclStatement report_power_guide
    syn keyword tclStatement report_power_options
    syn keyword tclStatement report_power_pin_info
    syn keyword tclStatement report_power_switch
    syn keyword tclStatement report_preferred_routing_direction
    syn keyword tclStatement report_preroute_drc_strategy
    syn keyword tclStatement report_primetime_options
    syn keyword tclStatement report_pst
    syn keyword tclStatement report_qor
    syn keyword tclStatement report_qor_snapshot
    syn keyword tclStatement report_qtm_model
    syn keyword tclStatement report_rail_options
    syn keyword tclStatement report_reference
    syn keyword tclStatement report_retention_cell
    syn keyword tclStatement report_route_opt_strategy
    syn keyword tclStatement report_route_options
    syn keyword tclStatement report_route_zrt_common_options
    syn keyword tclStatement report_route_zrt_detail_options
    syn keyword tclStatement report_route_zrt_global_options
    syn keyword tclStatement report_route_zrt_track_options
    syn keyword tclStatement report_routing_rules
    syn keyword tclStatement report_rp_group_options
    syn keyword tclStatement report_saif
    syn keyword tclStatement report_scan_chain
    syn keyword tclStatement report_scenario_options
    syn keyword tclStatement report_scenarios
    syn keyword tclStatement report_si_options
    syn keyword tclStatement report_signal_em
    syn keyword tclStatement report_skew_group
    syn keyword tclStatement report_spacing_rules
    syn keyword tclStatement report_split_clock_gates_options
    syn keyword tclStatement report_starrcxt_options
    syn keyword tclStatement report_supply_net
    syn keyword tclStatement report_supply_port
    syn keyword tclStatement report_target_library_subset
    syn keyword tclStatement report_threshold_voltage_group
    syn keyword tclStatement report_tie_nets
    syn keyword tclStatement report_timing
    syn keyword tclStatement report_timing_derate
    syn keyword tclStatement report_timing_requirements
    syn keyword tclStatement report_tlu_plus_files
    syn keyword tclStatement report_track
    syn keyword tclStatement report_transitive_fanin
    syn keyword tclStatement report_transitive_fanout
    syn keyword tclStatement report_units
    syn keyword tclStatement report_voltage_area
    syn keyword tclStatement report_vt_filler_rule
    syn keyword tclStatement report_write_stream_options
    syn keyword tclStatement report_xtalk_route_options
    syn keyword tclStatement report_zrt_net_properties
    syn keyword tclStatement reset_clock_tree_optimization_options
    syn keyword tclStatement reset_clock_tree_options
    syn keyword tclStatement reset_clock_tree_references
    syn keyword tclStatement reset_cts_batch_mode
    syn keyword tclStatement reset_design
    syn keyword tclStatement reset_fp_clock_plan_options
    syn keyword tclStatement reset_latency_adjustment_options
    syn keyword tclStatement reset_mode
    syn keyword tclStatement reset_path
    syn keyword tclStatement reset_split_clock_gates_options
    syn keyword tclStatement reset_switching_activity
    syn keyword tclStatement reset_timing_derate
    syn keyword tclStatement reset_upf
    syn keyword tclStatement resize_objects
    syn keyword tclStatement resize_polygon
    syn keyword tclStatement restore_design_settings
    syn keyword tclStatement return
    syn keyword tclStatement rotate_objects
    syn keyword tclStatement route_area
    syn keyword tclStatement route_auto
    syn keyword tclStatement route_detail
    syn keyword tclStatement route_differential
    syn keyword tclStatement route_eco
    syn keyword tclStatement route_flip_chip
    syn keyword tclStatement route_fp_proto
    syn keyword tclStatement route_global
    syn keyword tclStatement route_group
    syn keyword tclStatement route_htree
    syn keyword tclStatement route_mesh_net
    syn keyword tclStatement route_opt
    syn keyword tclStatement route_rc_reduction
    syn keyword tclStatement route_search_repair
    syn keyword tclStatement route_spreadwires
    syn keyword tclStatement route_track
    syn keyword tclStatement route_widen_wire
    syn keyword tclStatement route_zrt_auto
    syn keyword tclStatement route_zrt_clock_tree
    syn keyword tclStatement route_zrt_detail
    syn keyword tclStatement route_zrt_eco
    syn keyword tclStatement route_zrt_global
    syn keyword tclStatement route_zrt_group
    syn keyword tclStatement route_zrt_track
    syn keyword tclStatement route_zrt_with_route_guidance
    syn keyword tclStatement rp_group_inclusions
    syn keyword tclStatement rp_group_instantiations
    syn keyword tclStatement rp_group_references
    syn keyword tclStatement run_parallel_jobs
    syn keyword tclStatement run_signoff
    syn keyword tclStatement save_design_settings
    syn keyword tclStatement save_mw_cel
    syn keyword tclStatement save_qtm_model
    syn keyword tclStatement save_upf
    syn keyword tclStatement scan
    syn keyword tclStatement seek
    syn keyword tclStatement select_mim_master_instance
    syn keyword tclStatement send_flow_status
    syn keyword tclStatement set
    syn keyword tclStatement set_active_scenarios
    syn keyword tclStatement set_ahfs_options
    syn keyword tclStatement set_always_on_cell
    syn keyword tclStatement set_always_on_strategy
    syn keyword tclStatement set_annotated_check
    syn keyword tclStatement set_annotated_delay
    syn keyword tclStatement set_annotated_transition
    syn keyword tclStatement set_aocvm_coefficient
    syn keyword tclStatement set_app_var
    syn keyword tclStatement set_area_recovery_options
    syn keyword tclStatement set_attribute
    syn keyword tclStatement set_auto_disable_drc_nets
    syn keyword tclStatement set_buffer_opt_strategy
    syn keyword tclStatement set_case_analysis
    syn keyword tclStatement set_cbt_options
    syn keyword tclStatement set_cell_degradation
    syn keyword tclStatement set_cell_internal_power
    syn keyword tclStatement set_cell_location
    syn keyword tclStatement set_cell_row_type
    syn keyword tclStatement set_cell_type
    syn keyword tclStatement set_cell_vt_type
    syn keyword tclStatement set_check_library_options
    syn keyword tclStatement set_checkpoint_strategy
    syn keyword tclStatement set_child_terminal
    syn keyword tclStatement set_chiplevel_pad_physical_constraints
    syn keyword tclStatement set_cle_options
    syn keyword tclStatement set_clock_gating_check
    syn keyword tclStatement set_clock_gating_registers
    syn keyword tclStatement set_clock_groups
    syn keyword tclStatement set_clock_latency
    syn keyword tclStatement set_clock_sense
    syn keyword tclStatement set_clock_transition
    syn keyword tclStatement set_clock_tree_exceptions
    syn keyword tclStatement set_clock_tree_optimization_options
    syn keyword tclStatement set_clock_tree_options
    syn keyword tclStatement set_clock_tree_references
    syn keyword tclStatement set_clock_uncertainty
    syn keyword tclStatement set_combinational_type
    syn keyword tclStatement set_congestion_options
    syn keyword tclStatement set_connection_class
    syn keyword tclStatement set_context_margin
    syn keyword tclStatement set_cost_priority
    syn keyword tclStatement set_critical_range
    syn keyword tclStatement set_cts_batch_mode
    syn keyword tclStatement set_cts_scenario
    syn keyword tclStatement set_current_command_mode
    syn keyword tclStatement set_data_check
    syn keyword tclStatement set_default_drive
    syn keyword tclStatement set_default_driving_cell
    syn keyword tclStatement set_default_fanout_load
    syn keyword tclStatement set_default_input_delay
    syn keyword tclStatement set_default_load
    syn keyword tclStatement set_default_output_delay
    syn keyword tclStatement set_delay_calculation
    syn keyword tclStatement set_delay_estimation_options
    syn keyword tclStatement set_design_license
    syn keyword tclStatement set_design_top
    syn keyword tclStatement set_die_area
    syn keyword tclStatement set_direct_power_rail_tie
    syn keyword tclStatement set_disable_clock_gating_check
    syn keyword tclStatement set_disable_timing
    syn keyword tclStatement set_distributed_route
    syn keyword tclStatement set_domain_supply_net
    syn keyword tclStatement set_dont_touch
    syn keyword tclStatement set_dont_touch_network
    syn keyword tclStatement set_dont_touch_placement
    syn keyword tclStatement set_dont_use
    syn keyword tclStatement set_dp_int_round
    syn keyword tclStatement set_drive
    syn keyword tclStatement set_driving_cell
    syn keyword tclStatement set_droute_options
    syn keyword tclStatement set_equal
    syn keyword tclStatement set_error_view_property
    syn keyword tclStatement set_extraction_options
    syn keyword tclStatement set_false_path
    syn keyword tclStatement set_fanout_load
    syn keyword tclStatement set_fast_mode
    syn keyword tclStatement set_feasibility_options
    syn keyword tclStatement set_fix_hold
    syn keyword tclStatement set_fix_hold_options
    syn keyword tclStatement set_fix_multiple_port_nets
    syn keyword tclStatement set_flip_chip_bump_attributes
    syn keyword tclStatement set_flip_chip_cell_site
    syn keyword tclStatement set_flip_chip_driver_array
    syn keyword tclStatement set_flip_chip_driver_island
    syn keyword tclStatement set_flip_chip_driver_ring
    syn keyword tclStatement set_flip_chip_grid
    syn keyword tclStatement set_flip_chip_options
    syn keyword tclStatement set_flip_chip_type
    syn keyword tclStatement set_fp_base_gate
    syn keyword tclStatement set_fp_black_boxes_estimated
    syn keyword tclStatement set_fp_black_boxes_unestimated
    syn keyword tclStatement set_fp_block_ring_constraints
    syn keyword tclStatement set_fp_clock_plan_options
    syn keyword tclStatement set_fp_flow_strategy
    syn keyword tclStatement set_fp_macro_array
    syn keyword tclStatement set_fp_macro_options
    syn keyword tclStatement set_fp_pin_constraints
    syn keyword tclStatement set_fp_placement_strategy
    syn keyword tclStatement set_fp_power_pad_constraints
    syn keyword tclStatement set_fp_rail_constraints
    syn keyword tclStatement set_fp_rail_region_constraints
    syn keyword tclStatement set_fp_rail_strategy
    syn keyword tclStatement set_fp_rail_voltage_area_constraints
    syn keyword tclStatement set_fp_relative_location
    syn keyword tclStatement set_fp_shaping_strategy
    syn keyword tclStatement set_fp_trace_mode
    syn keyword tclStatement set_fp_voltage_area_constraints
    syn keyword tclStatement set_groute_options
    syn keyword tclStatement set_hierarchy_color
    syn keyword tclStatement set_host_options
    syn keyword tclStatement set_ideal_latency
    syn keyword tclStatement set_ideal_net
    syn keyword tclStatement set_ideal_network
    syn keyword tclStatement set_ideal_transition
    syn keyword tclStatement set_ignore_cell_timing
    syn keyword tclStatement set_ignored_layers
    syn keyword tclStatement set_input_delay
    syn keyword tclStatement set_input_transition
    syn keyword tclStatement set_inter_clock_delay_options
    syn keyword tclStatement set_isolate_ports
    syn keyword tclStatement set_isolation
    syn keyword tclStatement set_isolation_cell
    syn keyword tclStatement set_isolation_control
    syn keyword tclStatement set_keepout_margin
    syn keyword tclStatement set_latency_adjustment_options
    syn keyword tclStatement set_left_right_filler_rule
    syn keyword tclStatement set_level_shifter
    syn keyword tclStatement set_level_shifter_cell
    syn keyword tclStatement set_level_shifter_strategy
    syn keyword tclStatement set_level_shifter_threshold
    syn keyword tclStatement set_lib_attribute
    syn keyword tclStatement set_lib_cell_spacing_label
    syn keyword tclStatement set_load
    syn keyword tclStatement set_local_link_library
    syn keyword tclStatement set_logic_dc
    syn keyword tclStatement set_logic_one
    syn keyword tclStatement set_logic_zero
    syn keyword tclStatement set_macro_cell_bound_spot
    syn keyword tclStatement set_max_area
    syn keyword tclStatement set_max_capacitance
    syn keyword tclStatement set_max_delay
    syn keyword tclStatement set_max_dynamic_power
    syn keyword tclStatement set_max_fanout
    syn keyword tclStatement set_max_leakage_power
    syn keyword tclStatement set_max_lvth_percentage
    syn keyword tclStatement set_max_net_length
    syn keyword tclStatement set_max_time_borrow
    syn keyword tclStatement set_max_total_power
    syn keyword tclStatement set_max_transition
    syn keyword tclStatement set_mcmm_job_options
    syn keyword tclStatement set_message_info
    syn keyword tclStatement set_min_capacitance
    syn keyword tclStatement set_min_delay
    syn keyword tclStatement set_min_library
    syn keyword tclStatement set_mode
    syn keyword tclStatement set_mpc_macro_array
    syn keyword tclStatement set_mpc_macro_options
    syn keyword tclStatement set_mpc_options
    syn keyword tclStatement set_mpc_pnet_options
    syn keyword tclStatement set_mpc_port_options
    syn keyword tclStatement set_mpc_rectilinear_outline
    syn keyword tclStatement set_mpc_ring_options
    syn keyword tclStatement set_mtcmos_pna_strategy
    syn keyword tclStatement set_multicycle_path
    syn keyword tclStatement set_mw_lib_reference
    syn keyword tclStatement set_mw_technology_file
    syn keyword tclStatement set_name
    syn keyword tclStatement set_net_aggressors
    syn keyword tclStatement set_net_routing_layer_constraints
    syn keyword tclStatement set_net_routing_rule
    syn keyword tclStatement set_object_boundary
    syn keyword tclStatement set_object_fixed_edit
    syn keyword tclStatement set_object_shape
    syn keyword tclStatement set_object_snap_type
    syn keyword tclStatement set_operand_isolation_scope
    syn keyword tclStatement set_operating_conditions
    syn keyword tclStatement set_opposite
    syn keyword tclStatement set_optimize_dft_options
    syn keyword tclStatement set_optimize_pre_cts_power_options
    syn keyword tclStatement set_output_delay
    syn keyword tclStatement set_pad_physical_constraints
    syn keyword tclStatement set_parameter
    syn keyword tclStatement set_partition_data
    syn keyword tclStatement set_pg_pin_model
    syn keyword tclStatement set_physical_signoff_options
    syn keyword tclStatement set_physopt_cpulimit_options
    syn keyword tclStatement set_pin_model
    syn keyword tclStatement set_pin_name_synonym
    syn keyword tclStatement set_pin_physical_constraints
    syn keyword tclStatement set_place_opt_cts_strategy
    syn keyword tclStatement set_pnet_options
    syn keyword tclStatement set_port_fanout_number
    syn keyword tclStatement set_port_location
    syn keyword tclStatement set_power_guide
    syn keyword tclStatement set_power_net_to_voltage_area
    syn keyword tclStatement set_power_options
    syn keyword tclStatement set_power_switch_cell
    syn keyword tclStatement set_prefer
    syn keyword tclStatement set_preferred_routing_direction
    syn keyword tclStatement set_preroute_advanced_via_rule
    syn keyword tclStatement set_preroute_drc_strategy
    syn keyword tclStatement set_preroute_special_rules
    syn keyword tclStatement set_primetime_options
    syn keyword tclStatement set_propagated_clock
    syn keyword tclStatement set_pulse_clock_cell
    syn keyword tclStatement set_qtm_global_parameter
    syn keyword tclStatement set_qtm_port_drive
    syn keyword tclStatement set_qtm_port_load
    syn keyword tclStatement set_qtm_technology
    syn keyword tclStatement set_rail_options
    syn keyword tclStatement set_register_type
    syn keyword tclStatement set_related_supply_net
    syn keyword tclStatement set_resistance
    syn keyword tclStatement set_retention
    syn keyword tclStatement set_retention_cell
    syn keyword tclStatement set_retention_control
    syn keyword tclStatement set_route_flip_chip_options
    syn keyword tclStatement set_route_mode_options
    syn keyword tclStatement set_route_opt_strategy
    syn keyword tclStatement set_route_options
    syn keyword tclStatement set_route_type
    syn keyword tclStatement set_route_zrt_common_options
    syn keyword tclStatement set_route_zrt_detail_options
    syn keyword tclStatement set_route_zrt_global_options
    syn keyword tclStatement set_route_zrt_track_options
    syn keyword tclStatement set_row_type
    syn keyword tclStatement set_rp_group_options
    syn keyword tclStatement set_scaling_lib_group
    syn keyword tclStatement set_scan_pin_type
    syn keyword tclStatement set_scenario_options
    syn keyword tclStatement set_scope
    syn keyword tclStatement set_si_options
    syn keyword tclStatement set_size_only
    syn keyword tclStatement set_skew_group
    syn keyword tclStatement set_spacing_label_rule
    syn keyword tclStatement set_split_clock_gates_options
    syn keyword tclStatement set_starrcxt_options
    syn keyword tclStatement set_switching_activity
    syn keyword tclStatement set_synlib_dont_get_license
    syn keyword tclStatement set_target_library_subset
    syn keyword tclStatement set_timing_derate
    syn keyword tclStatement set_timing_ranges
    syn keyword tclStatement set_tlu_plus_files
    syn keyword tclStatement set_true_delay_case_analysis
    syn keyword tclStatement set_unconnected
    syn keyword tclStatement set_undoable_attribute
    syn keyword tclStatement set_ungroup
    syn keyword tclStatement set_unix_variable
    syn keyword tclStatement set_user_grid
    syn keyword tclStatement set_via_array_size
    syn keyword tclStatement set_voltage
    syn keyword tclStatement set_voltage_model
    syn keyword tclStatement set_vt_filler_rule
    syn keyword tclStatement set_write_stream_options
    syn keyword tclStatement set_xtalk_route_options
    syn keyword tclStatement set_zero_interconnect_delay_mode
    syn keyword tclStatement set_zrt_net_properties
    syn keyword tclStatement setenv
    syn keyword tclStatement sh
    syn keyword tclStatement sh_list_key_bindings
    syn keyword tclStatement shape_fp_blocks
    syn keyword tclStatement shell_is_in_upf_mode
    syn keyword tclStatement signoff_drc
    syn keyword tclStatement signoff_metal_fill
    syn keyword tclStatement signoff_opt
    syn keyword tclStatement size_cell
    syn keyword tclStatement sizeof_collection
    syn keyword tclStatement skew_opt
    syn keyword tclStatement slot_wire
    syn keyword tclStatement snap_objects
    syn keyword tclStatement socket
    syn keyword tclStatement sort_collection
    syn keyword tclStatement sort_fp_pins
    syn keyword tclStatement source
    syn keyword tclStatement split
    syn keyword tclStatement split_clock_gates
    syn keyword tclStatement split_clock_net
    syn keyword tclStatement split_mw_lib
    syn keyword tclStatement split_net
    syn keyword tclStatement split_objects
    syn keyword tclStatement spread_spare_cells
    syn keyword tclStatement spread_zrt_wires
    syn keyword tclStatement start_gui
    syn keyword tclStatement stop_gui
    syn keyword tclStatement stretch_wire
    syn keyword tclStatement string
    syn keyword tclStatement sub_designs_of
    syn keyword tclStatement sub_instances_of
    syn keyword tclStatement subst
    syn keyword tclStatement suppress_message
    syn keyword tclStatement swap_cell_locations
    syn keyword tclStatement switch
    syn keyword tclStatement syntax_check
    syn keyword tclStatement synthesize_fp_rail
    syn keyword tclStatement tell
    syn keyword tclStatement time
    syn keyword tclStatement trace
    syn keyword tclStatement trace_scan_chain
    syn keyword tclStatement translate_zrt_parameters
    syn keyword tclStatement trim_fill_eco
    syn keyword tclStatement unalias
    syn keyword tclStatement uncommit_fp_soft_macros
    syn keyword tclStatement undefine_bus
    syn keyword tclStatement undo
    syn keyword tclStatement undo_config
    syn keyword tclStatement undo_mark
    syn keyword tclStatement ungroup
    syn keyword tclStatement uniquify
    syn keyword tclStatement uniquify_fp_mw_cel
    syn keyword tclStatement unset
    syn keyword tclStatement unset_hierarchy_color
    syn keyword tclStatement unset_power_guide
    syn keyword tclStatement unsuppress_message
    syn keyword tclStatement update
    syn keyword tclStatement update_bounds
    syn keyword tclStatement update_clock_latency
    syn keyword tclStatement update_flip_chip_pin_locations
    syn keyword tclStatement update_lib
    syn keyword tclStatement update_lib_model
    syn keyword tclStatement update_lib_pg_pin_model
    syn keyword tclStatement update_lib_pin_model
    syn keyword tclStatement update_lib_voltage_model
    syn keyword tclStatement update_physical_bus
    syn keyword tclStatement update_timing
    syn keyword tclStatement update_voltage_area
    syn keyword tclStatement uplevel
    syn keyword tclStatement upvar
    syn keyword tclStatement variable
    syn keyword tclStatement verify_drc
    syn keyword tclStatement verify_lvs
    syn keyword tclStatement verify_pg_nets
    syn keyword tclStatement verify_route
    syn keyword tclStatement verify_zrt_route
    syn keyword tclStatement vwait
    syn keyword tclStatement which
    syn keyword tclStatement while
    syn keyword tclStatement widen_zrt_wires
    syn keyword tclStatement win_select_objects
    syn keyword tclStatement win_set_filter
    syn keyword tclStatement win_set_select_class
    syn keyword tclStatement window_stretch
    syn keyword tclStatement write
    syn keyword tclStatement write_app_var
    syn keyword tclStatement write_def
    syn keyword tclStatement write_design_lib_paths
    syn keyword tclStatement write_design_settings
    syn keyword tclStatement write_environment
    syn keyword tclStatement write_flip_chip_bumps
    syn keyword tclStatement write_flip_chip_nets
    syn keyword tclStatement write_floorplan
    syn keyword tclStatement write_interface_timing
    syn keyword tclStatement write_io_constraints
    syn keyword tclStatement write_lib
    syn keyword tclStatement write_lib_specification_model
    syn keyword tclStatement write_link_library
    syn keyword tclStatement write_mw_lib_files
    syn keyword tclStatement write_parasitics
    syn keyword tclStatement write_physical_constraints
    syn keyword tclStatement write_physical_script
    syn keyword tclStatement write_plib
    syn keyword tclStatement write_qtm_model
    syn keyword tclStatement write_route
    syn keyword tclStatement write_rp_groups
    syn keyword tclStatement write_saif
    syn keyword tclStatement write_script
    syn keyword tclStatement write_sdc
    syn keyword tclStatement write_sdf
    syn keyword tclStatement write_stream
    syn keyword tclStatement write_verilog
"######################ICC Commands End ########################################

"######################ICC Variables Start ########################################
    syn keyword tclVarRef HIERARCHY_DELIMITER
    syn keyword tclVarRef _Variable_Groups
    syn keyword tclVarRef __err
    syn keyword tclVarRef access_internal_pins
    syn keyword tclVarRef alib_library_analysis_path
    syn keyword tclVarRef allow_input_delay_min_greater_than_max
    syn keyword tclVarRef annotation_control
    syn keyword tclVarRef arch
    syn keyword tclVarRef atpg_bidirect_output_only
    syn keyword tclVarRef auto_attr_spread_debug
    syn keyword tclVarRef auto_index
    syn keyword tclVarRef auto_insert_level_shifters
    syn keyword tclVarRef auto_insert_level_shifters_on_clocks
    syn keyword tclVarRef auto_link_disable
    syn keyword tclVarRef auto_link_options
    syn keyword tclVarRef auto_noexec
    syn keyword tclVarRef auto_oldpath
    syn keyword tclVarRef auto_path
    syn keyword tclVarRef auto_ungroup_preserve_constraints
    syn keyword tclVarRef auto_wire_load_selection
    syn keyword tclVarRef bin_path
    syn keyword tclVarRef bind_unused_hierarchical_pins
    syn keyword tclVarRef bpv_skip_designrulewidth_spacing_syntax
    syn keyword tclVarRef budget_generate_critical_range
    syn keyword tclVarRef budget_map_clock_gating_cells
    syn keyword tclVarRef budgeting_allow_negative_delays
    syn keyword tclVarRef budgeting_enable_hier_si
    syn keyword tclVarRef bus_inference_descending_sort
    syn keyword tclVarRef bus_inference_style
    syn keyword tclVarRef bus_minus_style
    syn keyword tclVarRef bus_multiple_separator_style
    syn keyword tclVarRef bus_naming_style
    syn keyword tclVarRef bus_range_separator_style
    syn keyword tclVarRef cache_dir_chmod_octal
    syn keyword tclVarRef cache_file_chmod_octal
    syn keyword tclVarRef case_analysis_log_file
    syn keyword tclVarRef case_analysis_propagate_through_icg
    syn keyword tclVarRef case_analysis_with_logic_constants
    syn keyword tclVarRef ccl_enable_always
    syn keyword tclVarRef change_names_bit_blast_negative_index
    syn keyword tclVarRef change_names_dont_change_bus_members
    syn keyword tclVarRef change_selection_no_coreARGS
    syn keyword tclVarRef change_selection_too_many_objectsARGS
    syn keyword tclVarRef check_design_allow_non_tri_drivers_on_tri_bus
    syn keyword tclVarRef check_design_allow_unknown_wired_logic_type
    syn keyword tclVarRef check_error_list
    syn keyword tclVarRef cmd
    syn keyword tclVarRef cmds
    syn keyword tclVarRef collection_deletion_effort
    syn keyword tclVarRef collection_result_display_limit
    syn keyword tclVarRef command_log_file
    syn keyword tclVarRef company
    syn keyword tclVarRef compatibility_version
    syn keyword tclVarRef compile_clock_gating_through_hierarchy
    syn keyword tclVarRef compile_dont_use_dedicated_scanout
    syn keyword tclVarRef compile_instance_name_prefix
    syn keyword tclVarRef compile_instance_name_suffix
    syn keyword tclVarRef compile_keep_original_for_external_references
    syn keyword tclVarRef compile_log_format
    syn keyword tclVarRef compile_power_domain_boundary_optimization
    syn keyword tclVarRef compile_retime_exception_registers
    syn keyword tclVarRef compile_seqmap_identify_shift_registers
    syn keyword tclVarRef compile_seqmap_identify_shift_registers_with_synchronous_logic
    syn keyword tclVarRef compile_ultra_ungroup_small_hierarchies
    syn keyword tclVarRef compile_use_fast_delay_mode
    syn keyword tclVarRef complete_mixed_mode_extraction
    syn keyword tclVarRef context_check_status
    syn keyword tclVarRef copy_metal_blockage_to_fram_view
    syn keyword tclVarRef cp_full_abut_cts_region_aware
    syn keyword tclVarRef cp_in_full_abut_mode
    syn keyword tclVarRef cp_para_max_subjob_num
    syn keyword tclVarRef create_clock_no_input_delay
    syn keyword tclVarRef ctldb_use_old_prot_flow
    syn keyword tclVarRef cts_add_clock_domain_name
    syn keyword tclVarRef cts_blockage_aware
    syn keyword tclVarRef cts_clock_opt_batch_mode
    syn keyword tclVarRef cts_clock_source_is_exclude_pin
    syn keyword tclVarRef cts_do_characterization
    syn keyword tclVarRef cts_enable_clock_at_hierarchical_pin
    syn keyword tclVarRef cts_enable_rc_constraints
    syn keyword tclVarRef cts_fix_clock_tree_sinks
    syn keyword tclVarRef cts_fix_drc_beyond_exceptions
    syn keyword tclVarRef cts_force_ilm_keep_full_clock_tree
    syn keyword tclVarRef cts_force_user_constraints
    syn keyword tclVarRef cts_instance_name_prefix
    syn keyword tclVarRef cts_move_clock_gate
    syn keyword tclVarRef cts_net_name_prefix
    syn keyword tclVarRef cts_prects_upsize_gates
    syn keyword tclVarRef cts_push_down_buffer
    syn keyword tclVarRef cts_rc_relax_factor
    syn keyword tclVarRef cts_region_aware
    syn keyword tclVarRef cts_target_cap
    syn keyword tclVarRef cts_target_transition
    syn keyword tclVarRef cts_traverse_dont_touch_subtrees
    syn keyword tclVarRef cts_use_debug_mode
    syn keyword tclVarRef cts_use_lib_max_fanout
    syn keyword tclVarRef cts_use_sdc_max_fanout
    syn keyword tclVarRef current_design
    syn keyword tclVarRef current_instance
    syn keyword tclVarRef date_time
    syn keyword tclVarRef db_load_ccs_data
    syn keyword tclVarRef db_load_ccs_noise_data
    syn keyword tclVarRef db_load_ccs_power_data
    syn keyword tclVarRef dc_lib_project_enabled
    syn keyword tclVarRef dcod_disable_chgmgr_fine_grain_notification
    syn keyword tclVarRef dcod_disable_chgmgr_notification
    syn keyword tclVarRef dct_placement_ignore_scan
    syn keyword tclVarRef ddc_allow_unknown_packed_commands
    syn keyword tclVarRef ddc_verbose
    syn keyword tclVarRef default_input_delay
    syn keyword tclVarRef default_name_rules
    syn keyword tclVarRef default_output_delay
    syn keyword tclVarRef default_port_connection_class
    syn keyword tclVarRef default_schematic_options
    syn keyword tclVarRef disable_auto_time_borrow
    syn keyword tclVarRef disable_case_analysis
    syn keyword tclVarRef disable_delta_slew_for_tran_cstr
    syn keyword tclVarRef disable_library_transition_degradation
    syn keyword tclVarRef do_operand_isolation
    syn keyword tclVarRef dont_cut_non_pin_metal_as_pin
    syn keyword tclVarRef dont_touch_nets_with_size_only_cells
    syn keyword tclVarRef dont_trim_via_region_by_cell_boundary
    syn keyword tclVarRef droute_advRouteCompletionEffort
    syn keyword tclVarRef droute_advRouteLoop
    syn keyword tclVarRef droute_advancedRouteLoops
    syn keyword tclVarRef droute_areaSrLoop
    syn keyword tclVarRef droute_autoSaveInterval
    syn keyword tclVarRef droute_autoSrLoop
    syn keyword tclVarRef droute_checkFixedDRC
    syn keyword tclVarRef droute_connBrokenNet
    syn keyword tclVarRef droute_connTieOff
    syn keyword tclVarRef droute_connTieRail
    syn keyword tclVarRef droute_doMaxCapConx
    syn keyword tclVarRef droute_doMaxTransConx
    syn keyword tclVarRef droute_doProbeConx
    syn keyword tclVarRef droute_doSelectedNetAntennaConx
    syn keyword tclVarRef droute_doXtalkConx
    syn keyword tclVarRef droute_ecoListToFile
    syn keyword tclVarRef droute_ecoMode
    syn keyword tclVarRef droute_ecoScope
    syn keyword tclVarRef droute_ecoSrLoop
    syn keyword tclVarRef droute_enableFullSBExtLevel
    syn keyword tclVarRef droute_enable_one_pass_partitioning
    syn keyword tclVarRef droute_expandFillTracks
    syn keyword tclVarRef droute_fillDataType
    syn keyword tclVarRef droute_fillEndByMinSpcPercent
    syn keyword tclVarRef droute_fillMetalCloseToMinDensityValue
    syn keyword tclVarRef droute_fillMetalUniformly
    syn keyword tclVarRef droute_fillViaDataType
    syn keyword tclVarRef droute_fixIsoViaTouchClock
    syn keyword tclVarRef droute_fixIsoViaTouchPG
    syn keyword tclVarRef droute_fixMinEdgeLengthByFilling
    syn keyword tclVarRef droute_flccNoRollBack
    syn keyword tclVarRef droute_followPolyTrkForPolyFill
    syn keyword tclVarRef droute_groupSrLoop
    syn keyword tclVarRef droute_highEffortViaDoubling
    syn keyword tclVarRef droute_lowSkewClkRoute
    syn keyword tclVarRef droute_m10MacroDensity
    syn keyword tclVarRef droute_m11MacroDensity
    syn keyword tclVarRef droute_m12MacroDensity
    syn keyword tclVarRef droute_m13MacroDensity
    syn keyword tclVarRef droute_m14MacroDensity
    syn keyword tclVarRef droute_m15MacroDensity
    syn keyword tclVarRef droute_m1MacroDensity
    syn keyword tclVarRef droute_m1NoWrongWayExtraCost
    syn keyword tclVarRef droute_m2MacroDensity
    syn keyword tclVarRef droute_m3MacroDensity
    syn keyword tclVarRef droute_m4MacroDensity
    syn keyword tclVarRef droute_m5MacroDensity
    syn keyword tclVarRef droute_m6MacroDensity
    syn keyword tclVarRef droute_m7MacroDensity
    syn keyword tclVarRef droute_m8MacroDensity
    syn keyword tclVarRef droute_m9MacroDensity
    syn keyword tclVarRef droute_maxOffGridTrack
    syn keyword tclVarRef droute_maxTieOffDistance
    syn keyword tclVarRef droute_metalFillDensityIncrement
    syn keyword tclVarRef droute_minLengthCheckCutMode
    syn keyword tclVarRef droute_minShieldLength
    syn keyword tclVarRef droute_numCPUs
    syn keyword tclVarRef droute_offGridCost
    syn keyword tclVarRef droute_offsetFillTrack
    syn keyword tclVarRef droute_optDelaySlackTarget
    syn keyword tclVarRef droute_optDelaySrLoop
    syn keyword tclVarRef droute_optSetup
    syn keyword tclVarRef droute_optSrLoop
    syn keyword tclVarRef droute_optViaHoldTimeThreshold
    syn keyword tclVarRef droute_optViaReportExcludedNets
    syn keyword tclVarRef droute_optViaSetupSlackThreshold
    syn keyword tclVarRef droute_optViaSrLoop
    syn keyword tclVarRef droute_optViaTimingDriven
    syn keyword tclVarRef droute_optimizeRouteGroup
    syn keyword tclVarRef droute_parallelLengthMode
    syn keyword tclVarRef droute_pinTaperLengthLimit
    syn keyword tclVarRef droute_pinTaperMode
    syn keyword tclVarRef droute_polyMacroDensity
    syn keyword tclVarRef droute_polycontMacroDensity
    syn keyword tclVarRef droute_reduceFatExtensionRange
    syn keyword tclVarRef droute_reportLimit
    syn keyword tclVarRef droute_rerouteUserWire
    syn keyword tclVarRef droute_rerunDRC
    syn keyword tclVarRef droute_resetMinMaxLayer
    syn keyword tclVarRef droute_shieldAvoidFatViaArray
    syn keyword tclVarRef droute_shieldLimitSboxExt
    syn keyword tclVarRef droute_shieldRerouteSignalNets
    syn keyword tclVarRef droute_shieldSkipNotShieldedSboxes
    syn keyword tclVarRef droute_shieldTieAsShield
    syn keyword tclVarRef droute_shieldTieForce
    syn keyword tclVarRef droute_shieldViaMinSpacing
    syn keyword tclVarRef droute_smallJogMinLength
    syn keyword tclVarRef droute_srLoop
    syn keyword tclVarRef droute_stopIfNoLicense
    syn keyword tclVarRef droute_suppressIllegalContactMsg
    syn keyword tclVarRef droute_timeLimit
    syn keyword tclVarRef droute_timingDriven
    syn keyword tclVarRef droute_timingSpace
    syn keyword tclVarRef droute_treatTiedFillAsFillToFillSpacing
    syn keyword tclVarRef droute_trimUserAntenna
    syn keyword tclVarRef droute_ultraWideWireMode
    syn keyword tclVarRef droute_via10MacroDensity
    syn keyword tclVarRef droute_via11MacroDensity
    syn keyword tclVarRef droute_via12MacroDensity
    syn keyword tclVarRef droute_via13MacroDensity
    syn keyword tclVarRef droute_via14MacroDensity
    syn keyword tclVarRef droute_via1MacroDensity
    syn keyword tclVarRef droute_via2MacroDensity
    syn keyword tclVarRef droute_via3MacroDensity
    syn keyword tclVarRef droute_via4MacroDensity
    syn keyword tclVarRef droute_via5MacroDensity
    syn keyword tclVarRef droute_via6MacroDensity
    syn keyword tclVarRef droute_via7MacroDensity
    syn keyword tclVarRef droute_via8MacroDensity
    syn keyword tclVarRef droute_via9MacroDensity
    syn keyword tclVarRef droute_wireWidenForceWrongWay
    syn keyword tclVarRef droute_wireWidenIgnoreMinEdgeLengthVio
    syn keyword tclVarRef droute_wireWidenMinLength
    syn keyword tclVarRef droute_wireWidenPieceWise
    syn keyword tclVarRef droute_wireWidenSrLoop
    syn keyword tclVarRef droute_wireWidenTimingDriven
    syn keyword tclVarRef droute_wireWidenWidthScheme
    syn keyword tclVarRef droute_wrongWayExtraCost
    syn keyword tclVarRef duplicate_ports
    syn keyword tclVarRef echo_include_commands
    syn keyword tclVarRef eco_align_design_verbose
    syn keyword tclVarRef eco_allow_register_type_difference
    syn keyword tclVarRef eco_connect_resource_cell_inputs
    syn keyword tclVarRef eco_correspondence_analysis_verbose
    syn keyword tclVarRef eco_directives_verbose
    syn keyword tclVarRef eco_implement_effort_level
    syn keyword tclVarRef eco_instance_name_prefix
    syn keyword tclVarRef eco_recycle_verbose
    syn keyword tclVarRef eco_remap_register_verbose
    syn keyword tclVarRef eco_reuse_verbose
    syn keyword tclVarRef enable_auto_attr_spread
    syn keyword tclVarRef enable_bus_name_mapping
    syn keyword tclVarRef enable_cell_based_verilog_reader
    syn keyword tclVarRef enable_instances_in_report_net
    syn keyword tclVarRef enable_lib_cell_case_sensitivity
    syn keyword tclVarRef enable_page_mode
    syn keyword tclVarRef enable_recovery_removal_arcs
    syn keyword tclVarRef enable_slew_degradation
    syn keyword tclVarRef enable_special_level_shifter_naming
    syn keyword tclVarRef enable_verilog_netlist_reader
    syn keyword tclVarRef enlarge_45degree_geometry_sliced_value
    syn keyword tclVarRef err
    syn keyword tclVarRef estimate_io_latency
    syn keyword tclVarRef estimate_resource_preference
    syn keyword tclVarRef exit_delete_command_log_file
    syn keyword tclVarRef exit_delete_filename_log_file
    syn keyword tclVarRef external_pin_file
    syn keyword tclVarRef filename_log_file
    syn keyword tclVarRef find_allow_only_non_hier_ports
    syn keyword tclVarRef find_converts_name_lists
    syn keyword tclVarRef find_ignore_case
    syn keyword tclVarRef focalopt_endpoint_margin
    syn keyword tclVarRef font_library
    syn keyword tclVarRef fp_allocate_mcmm_script_dir
    syn keyword tclVarRef fp_bb_flow
    syn keyword tclVarRef fp_snap_type
    syn keyword tclVarRef fsm_auto_inferring
    syn keyword tclVarRef fsm_enable_state_minimization
    syn keyword tclVarRef fsm_export_formality_state_info
    syn keyword tclVarRef gen_bussing_exact_implicit
    syn keyword tclVarRef gen_cell_pin_name_separator
    syn keyword tclVarRef gen_create_netlist_busses
    syn keyword tclVarRef gen_dont_show_single_bit_busses
    syn keyword tclVarRef gen_match_ripper_wire_widths
    syn keyword tclVarRef gen_max_compound_name_length
    syn keyword tclVarRef gen_max_ports_on_symbol_side
    syn keyword tclVarRef gen_open_name_postfix
    syn keyword tclVarRef gen_open_name_prefix
    syn keyword tclVarRef gen_show_created_busses
    syn keyword tclVarRef gen_show_created_symbols
    syn keyword tclVarRef gen_single_osc_per_name
    syn keyword tclVarRef generate_via_region_when_pin_width_all_less_than_via_width
    syn keyword tclVarRef generic_symbol_library
    syn keyword tclVarRef ggui_use_mw_collections
    syn keyword tclVarRef groute_VABoundaryToLSWeight
    syn keyword tclVarRef groute_avoidCouplingUser
    syn keyword tclVarRef groute_avoidXtalk
    syn keyword tclVarRef groute_blncdToSkewCntrlRatio
    syn keyword tclVarRef groute_blockEdgeAccess
    syn keyword tclVarRef groute_brokenNetsThresholdPercent
    syn keyword tclVarRef groute_clockBalanced
    syn keyword tclVarRef groute_clockComb
    syn keyword tclVarRef groute_combDistance
    syn keyword tclVarRef groute_combMaxConnections
    syn keyword tclVarRef groute_compactMode
    syn keyword tclVarRef groute_congestionWeight
    syn keyword tclVarRef groute_densityDriven
    syn keyword tclVarRef groute_detourLimitMinNetLen
    syn keyword tclVarRef groute_extraCostsApplyPercent
    syn keyword tclVarRef groute_extraWireLengthOpt
    syn keyword tclVarRef groute_forceUpperLayersForCritNets
    syn keyword tclVarRef groute_horReserveTracks
    syn keyword tclVarRef groute_ignoreViaBlockage
    syn keyword tclVarRef groute_incremental
    syn keyword tclVarRef groute_macroBndryDir
    syn keyword tclVarRef groute_macroBndryExt
    syn keyword tclVarRef groute_macroBndryTrkUtil
    syn keyword tclVarRef groute_macroBndryWidth
    syn keyword tclVarRef groute_macroCornerTrkUtil
    syn keyword tclVarRef groute_mapOnly
    syn keyword tclVarRef groute_maxDetourPercent
    syn keyword tclVarRef groute_netCriticality
    syn keyword tclVarRef groute_noTopLevelBusFeedThroughs
    syn keyword tclVarRef groute_numXtalkWindow
    syn keyword tclVarRef groute_paEqPinNetMaxPort
    syn keyword tclVarRef groute_powerDriven
    syn keyword tclVarRef groute_rcOptByLength
    syn keyword tclVarRef groute_reportDemandOnly
    syn keyword tclVarRef groute_reportEffectiveOverflow
    syn keyword tclVarRef groute_reportGCellDensity
    syn keyword tclVarRef groute_reportNetOrdering
    syn keyword tclVarRef groute_reserveTracksForPowerFile
    syn keyword tclVarRef groute_skewControl
    syn keyword tclVarRef groute_skewControlNetBBLowBound
    syn keyword tclVarRef groute_skewControlWeight
    syn keyword tclVarRef groute_speed
    syn keyword tclVarRef groute_timingDriven
    syn keyword tclVarRef groute_timingWeight
    syn keyword tclVarRef groute_turboMode
    syn keyword tclVarRef groute_verReserveTracks
    syn keyword tclVarRef groute_xtalkWeight
    syn keyword tclVarRef gui_auto_start
    syn keyword tclVarRef gui_custom_setup_files
    syn keyword tclVarRef gui_default_window_type
    syn keyword tclVarRef gui_disable_custom_setup
    syn keyword tclVarRef gui_online_browser
    syn keyword tclVarRef hdlin_auto_save_templates
    syn keyword tclVarRef hdlin_enable_assertions
    syn keyword tclVarRef hdlin_enable_elaborate_ref_linking
    syn keyword tclVarRef hdlin_mux_size_only
    syn keyword tclVarRef hdlin_optimize_pla_effort
    syn keyword tclVarRef hdlin_reporting_level
    syn keyword tclVarRef hdlin_sv_ieee_assignment_patterns
    syn keyword tclVarRef hdlin_sv_packages
    syn keyword tclVarRef hercules_home_dir
    syn keyword tclVarRef hier_dont_trace_ungroup
    syn keyword tclVarRef high_fanout_net_pin_capacitance
    syn keyword tclVarRef high_fanout_net_threshold
    syn keyword tclVarRef host_core
    syn keyword tclVarRef host_cpu
    syn keyword tclVarRef host_file
    syn keyword tclVarRef host_mem
    syn keyword tclVarRef host_model
    syn keyword tclVarRef host_name
    syn keyword tclVarRef icc_magnetpl_stop_after_seq_cell
    syn keyword tclVarRef icc_snapshot_storage_location
    syn keyword tclVarRef icv_home_dir
    syn keyword tclVarRef ignoreStackViaOnPG
    syn keyword tclVarRef ignore_binding_open_pins
    syn keyword tclVarRef ignore_guardband
    syn keyword tclVarRef ilm_enable_power_calculation
    syn keyword tclVarRef ilm_ignore_percentage
    syn keyword tclVarRef ilm_preserve_core_constraints
    syn keyword tclVarRef in_gui_session
    syn keyword tclVarRef infer_name_hierarchy
    syn keyword tclVarRef inherit_parent_dont_touch
    syn keyword tclVarRef init_path
    syn keyword tclVarRef initial_target_library
    syn keyword tclVarRef insert_dft_clean_up
    syn keyword tclVarRef insert_test_design_naming_style
    syn keyword tclVarRef lbo_cells_in_regions
    syn keyword tclVarRef lc
    syn keyword tclVarRef ldd_return_val
    syn keyword tclVarRef level_shifter_naming_prefix
    syn keyword tclVarRef lib_thresholds_per_lib
    syn keyword tclVarRef lib_use_thresholds_per_pin
    syn keyword tclVarRef libgen_max_differences
    syn keyword tclVarRef libsetup_macro_opcond_inference_level
    syn keyword tclVarRef libsetup_match_pt_for_macro_pad
    syn keyword tclVarRef libsetup_max_auto_opcond_message
    syn keyword tclVarRef libsetup_pad_opcond_inference_level
    syn keyword tclVarRef libsetup_switch_opcond_inference_level
    syn keyword tclVarRef link_force_case
    syn keyword tclVarRef link_library
    syn keyword tclVarRef link_path
    syn keyword tclVarRef ltl_obstruction_type
    syn keyword tclVarRef magnet_placement_disable_overlap
    syn keyword tclVarRef magnet_placement_fanout_limit
    syn keyword tclVarRef mcmm_enable_high_capacity_flow
    syn keyword tclVarRef mcmm_high_capacity_effort_level
    syn keyword tclVarRef monitor_cpu_memory
    syn keyword tclVarRef motif_files
    syn keyword tclVarRef mpc_disable_macro_fitting
    syn keyword tclVarRef mpc_disable_pad_legalization
    syn keyword tclVarRef mpc_dont_cut_pnet_over_macros
    syn keyword tclVarRef multi_pass_test_generation
    syn keyword tclVarRef mux_auto_inferring_effort
    syn keyword tclVarRef mv_allow_ls_on_leaf_pin_boundary
    syn keyword tclVarRef mv_size_only_level_shifters
    syn keyword tclVarRef mv_use_std_cell_for_isolation
    syn keyword tclVarRef mw_allow_rect_and_polygon_in_def
    syn keyword tclVarRef mw_attr_value_extra_braces
    syn keyword tclVarRef mw_attr_value_no_space
    syn keyword tclVarRef mw_cel_as_escaped
    syn keyword tclVarRef mw_cell_name
    syn keyword tclVarRef mw_create_netlist_from_CEL
    syn keyword tclVarRef mw_current_design
    syn keyword tclVarRef mw_design_library
    syn keyword tclVarRef mw_disable_escape_char
    syn keyword tclVarRef mw_enable_net_bus
    syn keyword tclVarRef mw_ground_port
    syn keyword tclVarRef mw_hdl_bus_dir_for_undef_cell
    syn keyword tclVarRef mw_hdl_expand_cell_with_no_instance
    syn keyword tclVarRef mw_hdl_stop_at_FRAM_cells
    syn keyword tclVarRef mw_hdl_top_module_list
    syn keyword tclVarRef mw_logic0_net
    syn keyword tclVarRef mw_logic1_net
    syn keyword tclVarRef mw_open_design_with_gui
    syn keyword tclVarRef mw_pgconn_cell_inst
    syn keyword tclVarRef mw_pgconn_cell_master
    syn keyword tclVarRef mw_power_port
    syn keyword tclVarRef mw_read_ignore_corner_cell
    syn keyword tclVarRef mw_read_ignore_filler_cell
    syn keyword tclVarRef mw_read_ignore_pad_cell
    syn keyword tclVarRef mw_read_ignore_unconnected_cell
    syn keyword tclVarRef mw_reference_library
    syn keyword tclVarRef mw_site_name_mapping
    syn keyword tclVarRef mw_use_pdb_lib_format
    syn keyword tclVarRef mwdc_allow_higher_mem_usage
    syn keyword tclVarRef new_idn_switch
    syn keyword tclVarRef no_routing_blockage_output_on_masks
    syn keyword tclVarRef open_soft_macro_push_down_shapes
    syn keyword tclVarRef optimize_reg_always_insert_sequential
    syn keyword tclVarRef optimize_reg_max_time_borrow
    syn keyword tclVarRef optimize_reg_retime_clock_gating_latches
    syn keyword tclVarRef physopt_area_critical_range
    syn keyword tclVarRef physopt_cell_count_threshold
    syn keyword tclVarRef physopt_change_list
    syn keyword tclVarRef physopt_check_site_array_overlap
    syn keyword tclVarRef physopt_checkpoint_stage
    syn keyword tclVarRef physopt_cpu_limit
    syn keyword tclVarRef physopt_create_missing_physical_libcells
    syn keyword tclVarRef physopt_delete_unloaded_cells
    syn keyword tclVarRef physopt_dw_opto
    syn keyword tclVarRef physopt_enable_extractor_rc
    syn keyword tclVarRef physopt_enable_power_optimization
    syn keyword tclVarRef physopt_enable_router_process
    syn keyword tclVarRef physopt_enable_rp_in_xg_mode
    syn keyword tclVarRef physopt_enable_tlu_plus
    syn keyword tclVarRef physopt_enable_tlu_plus_process
    syn keyword tclVarRef physopt_enable_via_res_support
    syn keyword tclVarRef physopt_hard_keepout_distance
    syn keyword tclVarRef physopt_heterogeneous_site_array
    syn keyword tclVarRef physopt_ignore_lpin_fanout
    syn keyword tclVarRef physopt_ignore_structure
    syn keyword tclVarRef physopt_macro_cell_height_threshold
    syn keyword tclVarRef physopt_mw_checkpoint_filename
    syn keyword tclVarRef physopt_new_fix_constants
    syn keyword tclVarRef physopt_pin_based_pad
    syn keyword tclVarRef physopt_power_critical_range
    syn keyword tclVarRef physopt_ref_pdef_loaded
    syn keyword tclVarRef physopt_row_overlap_threshold
    syn keyword tclVarRef physopt_rp_enable_orient_opt
    syn keyword tclVarRef physopt_spatial_constraint_lists
    syn keyword tclVarRef physopt_tie_const_cells
    syn keyword tclVarRef physopt_tie_spare_cells
    syn keyword tclVarRef physopt_ultra_high_area_effort
    syn keyword tclVarRef placer_disable_auto_bound_for_gated_clock
    syn keyword tclVarRef placer_disable_macro_placement_timeout
    syn keyword tclVarRef placer_dont_error_out_on_conflicting_bounds
    syn keyword tclVarRef placer_enable_enhanced_router
    syn keyword tclVarRef placer_gated_register_area_multiplier
    syn keyword tclVarRef placer_max_cell_density_threshold
    syn keyword tclVarRef placer_run_in_separate_process
    syn keyword tclVarRef placer_soft_keepout_channel_width
    syn keyword tclVarRef port_complement_naming_style
    syn keyword tclVarRef power_cg_all_registers
    syn keyword tclVarRef power_cg_auto_identify
    syn keyword tclVarRef power_cg_balance_stages
    syn keyword tclVarRef power_cg_cell_naming_style
    syn keyword tclVarRef power_cg_derive_related_clock
    syn keyword tclVarRef power_cg_designware
    syn keyword tclVarRef power_cg_enable_alternative_algorithm
    syn keyword tclVarRef power_cg_ext_feedback_loop
    syn keyword tclVarRef power_cg_flatten
    syn keyword tclVarRef power_cg_gated_clock_net_naming_style
    syn keyword tclVarRef power_cg_ignore_setup_condition
    syn keyword tclVarRef power_cg_inherit_timing_exceptions
    syn keyword tclVarRef power_cg_module_naming_style
    syn keyword tclVarRef power_cg_print_enable_conditions
    syn keyword tclVarRef power_cg_print_enable_conditions_max_terms
    syn keyword tclVarRef power_cg_reconfig_stages
    syn keyword tclVarRef power_default_static_probability
    syn keyword tclVarRef power_default_toggle_rate
    syn keyword tclVarRef power_default_toggle_rate_type
    syn keyword tclVarRef power_do_not_size_icg_cells
    syn keyword tclVarRef power_driven_clock_gating
    syn keyword tclVarRef power_enable_one_pass_power_gating
    syn keyword tclVarRef power_enable_power_gating
    syn keyword tclVarRef power_fix_sdpd_annotation
    syn keyword tclVarRef power_fix_sdpd_annotation_verbose
    syn keyword tclVarRef power_hdlc_do_not_split_cg_cells
    syn keyword tclVarRef power_keep_license_after_power_commands
    syn keyword tclVarRef power_lib2saif_rise_fall_pd
    syn keyword tclVarRef power_min_internal_power_threshold
    syn keyword tclVarRef power_model_preference
    syn keyword tclVarRef power_opto_extra_high_dynamic_power_effort
    syn keyword tclVarRef power_preserve_rtl_hier_names
    syn keyword tclVarRef power_rclock_inputs_use_clocks_fanout
    syn keyword tclVarRef power_rclock_unrelated_use_fastest
    syn keyword tclVarRef power_rclock_use_asynch_inputs
    syn keyword tclVarRef power_remove_redundant_clock_gates
    syn keyword tclVarRef power_rtl_saif_file
    syn keyword tclVarRef power_sa_propagation_effort
    syn keyword tclVarRef power_sa_propagation_verbose
    syn keyword tclVarRef power_same_switching_activity_on_connected_objects
    syn keyword tclVarRef power_sdpd_message_tolerance
    syn keyword tclVarRef power_sdpd_saif_file
    syn keyword tclVarRef precise_cut_metal_blockage
    syn keyword tclVarRef preroute_AlignRailsEnds
    syn keyword tclVarRef preroute_ContactSizeSelection
    syn keyword tclVarRef preroute_DropViasToLargeAreaFirst
    syn keyword tclVarRef preroute_GcrEnable
    syn keyword tclVarRef preroute_SetDrcMenuFatBlockagesDefault
    syn keyword tclVarRef preroute_SetDrcMenuFatViaDefault
    syn keyword tclVarRef preroute_SetDrcMenuProtectAccessEdge
    syn keyword tclVarRef preroute_SetViaShare
    syn keyword tclVarRef preroute_StackingViaMaxNumberOfCut
    syn keyword tclVarRef preroute_TreatMaxNumRowsAsExactNumRows
    syn keyword tclVarRef preroute_UseCutLayerRule4ViaPair
    syn keyword tclVarRef preroute_UseFatContactIfBothWiresFat
    syn keyword tclVarRef preroute_advancedViasOnly
    syn keyword tclVarRef preroute_checkDRCforRailPins
    syn keyword tclVarRef preroute_cutStdRowsByPlacementBlockages
    syn keyword tclVarRef preroute_layerSwitching
    syn keyword tclVarRef preroute_regressionMode
    syn keyword tclVarRef preroute_rotateMinAreaStubOverRails
    syn keyword tclVarRef preroute_rotateViasToMaximizeCutsCount
    syn keyword tclVarRef preroute_trimWiresByViaCovers
    syn keyword tclVarRef preroute_tryOtherDirectionsIfFails
    syn keyword tclVarRef preroute_viaTargetWidthThreshold
    syn keyword tclVarRef product_build_date
    syn keyword tclVarRef product_version
    syn keyword tclVarRef psyn_ignore_bounds
    syn keyword tclVarRef psyn_ignore_mobility
    syn keyword tclVarRef psyn_onroute_disable_cap_drc
    syn keyword tclVarRef psyn_onroute_disable_fanout_drc
    syn keyword tclVarRef psyn_onroute_disable_hold_fix
    syn keyword tclVarRef psyn_onroute_disable_netlength_drc
    syn keyword tclVarRef psyn_onroute_disable_trans_drc
    syn keyword tclVarRef psyn_stress_map
    syn keyword tclVarRef psynopt_high_fanout_legality_limit
    syn keyword tclVarRef rc_degrade_min_slew_when_rd_less_than_rnet
    syn keyword tclVarRef rc_driver_model_mode
    syn keyword tclVarRef rc_input_threshold_pct_fall
    syn keyword tclVarRef rc_input_threshold_pct_rise
    syn keyword tclVarRef rc_noise_model_mode
    syn keyword tclVarRef rc_output_threshold_pct_fall
    syn keyword tclVarRef rc_output_threshold_pct_rise
    syn keyword tclVarRef rc_receiver_model_mode
    syn keyword tclVarRef rc_slew_derate_from_library
    syn keyword tclVarRef rc_slew_lower_threshold_pct_fall
    syn keyword tclVarRef rc_slew_lower_threshold_pct_rise
    syn keyword tclVarRef rc_slew_upper_threshold_pct_fall
    syn keyword tclVarRef rc_slew_upper_threshold_pct_rise
    syn keyword tclVarRef read_db_lib_warnings
    syn keyword tclVarRef read_translate_msff
    syn keyword tclVarRef register_duplicate
    syn keyword tclVarRef register_replication_naming_style
    syn keyword tclVarRef remove_route_guide_on_fat_pin
    syn keyword tclVarRef reoptimize_design_changed_list_file_name
    syn keyword tclVarRef report_default_significant_digits
    syn keyword tclVarRef represent_power_ground_pins_by_vertical_sliced_rectangles
    syn keyword tclVarRef rom_auto_inferring
    syn keyword tclVarRef route_doubleViaDriven
    syn keyword tclVarRef route_layerExtraCostByRC
    syn keyword tclVarRef route_m10ExtraCost
    syn keyword tclVarRef route_m10Freeze
    syn keyword tclVarRef route_m11ExtraCost
    syn keyword tclVarRef route_m11Freeze
    syn keyword tclVarRef route_m12ExtraCost
    syn keyword tclVarRef route_m12Freeze
    syn keyword tclVarRef route_m13ExtraCost
    syn keyword tclVarRef route_m13Freeze
    syn keyword tclVarRef route_m14ExtraCost
    syn keyword tclVarRef route_m14Freeze
    syn keyword tclVarRef route_m15ExtraCost
    syn keyword tclVarRef route_m15Freeze
    syn keyword tclVarRef route_m1ExtraCost
    syn keyword tclVarRef route_m1Freeze
    syn keyword tclVarRef route_m2ExtraCost
    syn keyword tclVarRef route_m2Freeze
    syn keyword tclVarRef route_m3ExtraCost
    syn keyword tclVarRef route_m3Freeze
    syn keyword tclVarRef route_m4ExtraCost
    syn keyword tclVarRef route_m4Freeze
    syn keyword tclVarRef route_m5ExtraCost
    syn keyword tclVarRef route_m5Freeze
    syn keyword tclVarRef route_m6ExtraCost
    syn keyword tclVarRef route_m6Freeze
    syn keyword tclVarRef route_m7ExtraCost
    syn keyword tclVarRef route_m7Freeze
    syn keyword tclVarRef route_m8ExtraCost
    syn keyword tclVarRef route_m8Freeze
    syn keyword tclVarRef route_m9ExtraCost
    syn keyword tclVarRef route_m9Freeze
    syn keyword tclVarRef route_noVoltAreaFeedThru
    syn keyword tclVarRef route_polyContExtraCost
    syn keyword tclVarRef route_polyExtraCost
    syn keyword tclVarRef route_polyFreeze
    syn keyword tclVarRef route_splitTimer
    syn keyword tclVarRef route_via10ExtraCost
    syn keyword tclVarRef route_via11ExtraCost
    syn keyword tclVarRef route_via12ExtraCost
    syn keyword tclVarRef route_via13ExtraCost
    syn keyword tclVarRef route_via1ExtraCost
    syn keyword tclVarRef route_via2ExtraCost
    syn keyword tclVarRef route_via3ExtraCost
    syn keyword tclVarRef route_via4ExtraCost
    syn keyword tclVarRef route_via5ExtraCost
    syn keyword tclVarRef route_via6ExtraCost
    syn keyword tclVarRef route_via7ExtraCost
    syn keyword tclVarRef route_via8ExtraCost
    syn keyword tclVarRef route_via9ExtraCost
    syn keyword tclVarRef route_viaFreeze
    syn keyword tclVarRef routeopt_allow_min_buffer_with_size_only
    syn keyword tclVarRef routeopt_checkpoint
    syn keyword tclVarRef routeopt_density_limit
    syn keyword tclVarRef routeopt_disable_cpulimit
    syn keyword tclVarRef routeopt_drc_over_timing
    syn keyword tclVarRef routeopt_preserve_routes
    syn keyword tclVarRef routeopt_skip_report_qor
    syn keyword tclVarRef routeopt_xtalk_reduction_setup_threshold
    syn keyword tclVarRef rp_shift_column_for_fixed_cells
    syn keyword tclVarRef sdc_version
    syn keyword tclVarRef sdc_write_unambiguous_names
    syn keyword tclVarRef sdf_enable_cond_start_end
    syn keyword tclVarRef sdfout_allow_non_positive_constraints
    syn keyword tclVarRef sdfout_min_fall_cell_delay
    syn keyword tclVarRef sdfout_min_fall_net_delay
    syn keyword tclVarRef sdfout_min_rise_cell_delay
    syn keyword tclVarRef sdfout_min_rise_net_delay
    syn keyword tclVarRef sdfout_time_scale
    syn keyword tclVarRef sdfout_top_instance_name
    syn keyword tclVarRef sdfout_write_to_output
    syn keyword tclVarRef search_path
    syn keyword tclVarRef set_isolate_ports
    syn keyword tclVarRef sh_allow_tcl_with_set_app_var
    syn keyword tclVarRef sh_allow_tcl_with_set_app_var_no_message_list
    syn keyword tclVarRef sh_arch
    syn keyword tclVarRef sh_command_abbrev_mode
    syn keyword tclVarRef sh_command_log_file
    syn keyword tclVarRef sh_continue_on_error
    syn keyword tclVarRef sh_dev_null
    syn keyword tclVarRef sh_enable_line_editing
    syn keyword tclVarRef sh_enable_page_mode
    syn keyword tclVarRef sh_enable_stdout_redirect
    syn keyword tclVarRef sh_line_editing_mode
    syn keyword tclVarRef sh_new_variable_message
    syn keyword tclVarRef sh_new_variable_message_in_proc
    syn keyword tclVarRef sh_new_variable_message_in_script
    syn keyword tclVarRef sh_output_log_file
    syn keyword tclVarRef sh_product_version
    syn keyword tclVarRef sh_script_stop_severity
    syn keyword tclVarRef sh_source_emits_line_numbers
    syn keyword tclVarRef sh_source_logging
    syn keyword tclVarRef sh_source_uses_search_path
    syn keyword tclVarRef sh_tcllib_app_dirname
    syn keyword tclVarRef sh_user_man_path
    syn keyword tclVarRef sheet_sizes
    syn keyword tclVarRef si_filter_accum_aggr_noise_peak_ratio
    syn keyword tclVarRef si_filter_per_aggr_noise_peak_ratio
    syn keyword tclVarRef si_use_partial_grounding_for_min_analysis
    syn keyword tclVarRef si_xtalk_reselect_delta_and_slack
    syn keyword tclVarRef si_xtalk_reselect_delta_delay
    syn keyword tclVarRef si_xtalk_reselect_delta_delay_ratio
    syn keyword tclVarRef si_xtalk_reselect_max_mode_slack
    syn keyword tclVarRef si_xtalk_reselect_min_mode_slack
    syn keyword tclVarRef signoff_enable_dmsa_fix_hold
    syn keyword tclVarRef signoff_enable_dmsa_fix_signoff
    syn keyword tclVarRef signoff_pt_dmsa_script_file
    syn keyword tclVarRef single_group_per_sheet
    syn keyword tclVarRef site_info_file
    syn keyword tclVarRef skew_opt_skip_clock_balancing
    syn keyword tclVarRef skew_opt_skip_ideal_clocks
    syn keyword tclVarRef skew_opt_skip_propagated_clocks
    syn keyword tclVarRef slice_signal_pin_vertically
    syn keyword tclVarRef sort_outputs
    syn keyword tclVarRef spatial_constraint_lists
    syn keyword tclVarRef suppress_errors
    syn keyword tclVarRef symbol_library
    syn keyword tclVarRef synopsys_exec
    syn keyword tclVarRef synopsys_program_name
    syn keyword tclVarRef synopsys_root
    syn keyword tclVarRef syntax_check_status
    syn keyword tclVarRef synthesized_clocks
    syn keyword tclVarRef synthetic_library
    syn keyword tclVarRef systemcout_debug_mode
    syn keyword tclVarRef systemcout_levelize
    syn keyword tclVarRef target_library
    syn keyword tclVarRef tcl_interactive
    syn keyword tclVarRef tcl_library
    syn keyword tclVarRef tcl_patchLevel
    syn keyword tclVarRef tcl_pkgPath
    syn keyword tclVarRef tcl_platform
    syn keyword tclVarRef tcl_version
    syn keyword tclVarRef template_naming_style
    syn keyword tclVarRef template_parameter_style
    syn keyword tclVarRef template_separator_style
    syn keyword tclVarRef tested_technology
    syn keyword tclVarRef testsim_print_stats_file
    syn keyword tclVarRef text_editor_command
    syn keyword tclVarRef text_print_command
    syn keyword tclVarRef text_unselect_on_button_press
    syn keyword tclVarRef timing_aocvm_enable_analysis
    syn keyword tclVarRef timing_ccs_load_on_demand
    syn keyword tclVarRef timing_check_defaults
    syn keyword tclVarRef timing_clock_gating_propagate_enable
    syn keyword tclVarRef timing_clock_reconvergence_pessimism
    syn keyword tclVarRef timing_crpr_remove_clock_to_data_crp
    syn keyword tclVarRef timing_crpr_threshold_ps
    syn keyword tclVarRef timing_disable_cond_default_arcs
    syn keyword tclVarRef timing_edge_specific_source_latency
    syn keyword tclVarRef timing_enable_multiple_clocks_per_reg
    syn keyword tclVarRef timing_enable_non_sequential_checks
    syn keyword tclVarRef timing_gclock_source_network_num_master_registers
    syn keyword tclVarRef timing_input_port_clock_shift_one_cycle
    syn keyword tclVarRef timing_input_port_default_clock
    syn keyword tclVarRef timing_non_unate_clock_compatibility
    syn keyword tclVarRef timing_remove_clock_reconvergence_pessimism
    syn keyword tclVarRef timing_report_attributes
    syn keyword tclVarRef timing_self_loops_no_skew
    syn keyword tclVarRef timing_separate_clock_gating_group
    syn keyword tclVarRef timing_single_core
    syn keyword tclVarRef timing_use_clock_specific_transition
    syn keyword tclVarRef timing_use_driver_arc_transition_at_clock_source
    syn keyword tclVarRef timing_use_enhanced_capacitance_modeling
    syn keyword tclVarRef trackAssign_XTalkParam
    syn keyword tclVarRef trackAssign_densityDriven
    syn keyword tclVarRef trackAssign_evenSpaceAdjustment
    syn keyword tclVarRef trackAssign_extraViaGridCheck
    syn keyword tclVarRef trackAssign_m0LayerLengthLimit
    syn keyword tclVarRef trackAssign_m10LayerLengthLimit
    syn keyword tclVarRef trackAssign_m11LayerLengthLimit
    syn keyword tclVarRef trackAssign_m12LayerLengthLimit
    syn keyword tclVarRef trackAssign_m13LayerLengthLimit
    syn keyword tclVarRef trackAssign_m14LayerLengthLimit
    syn keyword tclVarRef trackAssign_m15LayerLengthLimit
    syn keyword tclVarRef trackAssign_m1LayerLengthLimit
    syn keyword tclVarRef trackAssign_m2LayerLengthLimit
    syn keyword tclVarRef trackAssign_m3LayerLengthLimit
    syn keyword tclVarRef trackAssign_m4LayerLengthLimit
    syn keyword tclVarRef trackAssign_m5LayerLengthLimit
    syn keyword tclVarRef trackAssign_m6LayerLengthLimit
    syn keyword tclVarRef trackAssign_m7LayerLengthLimit
    syn keyword tclVarRef trackAssign_m8LayerLengthLimit
    syn keyword tclVarRef trackAssign_m9LayerLengthLimit
    syn keyword tclVarRef trackAssign_minimizeJog
    syn keyword tclVarRef trackAssign_netLayerLengthLimit
    syn keyword tclVarRef trackAssign_noOffGridRouting
    syn keyword tclVarRef trackAssign_noiseThreshold
    syn keyword tclVarRef trackAssign_numCPUs
    syn keyword tclVarRef trackAssign_parallelLimit
    syn keyword tclVarRef trackAssign_parallelLimitMode
    syn keyword tclVarRef trackAssign_runTimeMode
    syn keyword tclVarRef trackAssign_runTimingMode
    syn keyword tclVarRef trackAssign_runXTalkIter
    syn keyword tclVarRef trackAssign_runXTalkMode
    syn keyword tclVarRef trackAssign_timingCost
    syn keyword tclVarRef trackAssign_tryGlobalLayerFirst
    syn keyword tclVarRef trackAssign_tryGlobalLayerOnly
    syn keyword tclVarRef trackAssign_variableWidthAdjustment
    syn keyword tclVarRef transfer_reserved_metalblockage_within_pin_to_viablockage
    syn keyword tclVarRef trim_via_region_by_top_bottom_cell_boundary
    syn keyword tclVarRef ungroup_keep_original_design
    syn keyword tclVarRef uniquify_keep_original_design
    syn keyword tclVarRef uniquify_naming_style
    syn keyword tclVarRef upf_charz_allow_port_punch
    syn keyword tclVarRef upf_extension
    syn keyword tclVarRef upf_levshi_on_constraint_only
    syn keyword tclVarRef upf_version
    syn keyword tclVarRef useAbstractClockSchematic
    syn keyword tclVarRef use_ccs_in_sdn
    syn keyword tclVarRef use_port_name_for_oscs
    syn keyword tclVarRef var_mux_mbm
    syn keyword tclVarRef verbose_messages
    syn keyword tclVarRef veriloglib_enable
    syn keyword tclVarRef veriloglib_sdf_edge
    syn keyword tclVarRef veriloglib_tb_compare
    syn keyword tclVarRef veriloglib_tb_x_eq_dontcare
    syn keyword tclVarRef veriloglib_write_recrem_as_setuphold
    syn keyword tclVarRef verilogout_equation
    syn keyword tclVarRef verilogout_higher_designs_first
    syn keyword tclVarRef verilogout_ignore_case
    syn keyword tclVarRef verilogout_include_files
    syn keyword tclVarRef verilogout_no_negative_index
    syn keyword tclVarRef verilogout_no_tri
    syn keyword tclVarRef verilogout_show_unconnected_pins
    syn keyword tclVarRef verilogout_single_bit
    syn keyword tclVarRef verilogout_unconnected_prefix
    syn keyword tclVarRef via_can_change_pin_shape
    syn keyword tclVarRef via_output_layers_same_as_input
    syn keyword tclVarRef via_region_honor_multiple_cut_rule
    syn keyword tclVarRef view_analyze_file_suffix
    syn keyword tclVarRef view_arch_types
    syn keyword tclVarRef view_background
    syn keyword tclVarRef view_busy_during_selection
    syn keyword tclVarRef view_cache_images
    syn keyword tclVarRef view_command_log_file
    syn keyword tclVarRef view_command_win_max_lines
    syn keyword tclVarRef view_dialogs_modal
    syn keyword tclVarRef view_disable_cursor_warping
    syn keyword tclVarRef view_disable_error_windows
    syn keyword tclVarRef view_disable_output
    syn keyword tclVarRef view_draw_text_breakpoint
    syn keyword tclVarRef view_error_window_count
    syn keyword tclVarRef view_execute_script_suffix
    syn keyword tclVarRef view_extend_thick_lines
    syn keyword tclVarRef view_icon_path
    syn keyword tclVarRef view_independent_dialogs
    syn keyword tclVarRef view_info_search_cmd
    syn keyword tclVarRef view_log_file
    syn keyword tclVarRef view_maximum_route_grids
    syn keyword tclVarRef view_on_line_doc_cmd
    syn keyword tclVarRef view_read_file_suffix
    syn keyword tclVarRef view_report_append
    syn keyword tclVarRef view_report_interactive
    syn keyword tclVarRef view_report_output2file
    syn keyword tclVarRef view_script_submenu_items
    syn keyword tclVarRef view_select_default_message
    syn keyword tclVarRef view_select_separator
    syn keyword tclVarRef view_set_cursor_area
    syn keyword tclVarRef view_set_selecting_color
    syn keyword tclVarRef view_tools_menu_items
    syn keyword tclVarRef view_use_integer_scaling
    syn keyword tclVarRef view_use_small_cursor
    syn keyword tclVarRef view_use_x_routines
    syn keyword tclVarRef view_watcher
    syn keyword tclVarRef view_write_file_suffix
    syn keyword tclVarRef when_analysis_permitted
    syn keyword tclVarRef when_analysis_without_case_analysis
    syn keyword tclVarRef win_select_objects_remove_adds_net_routing
    syn keyword tclVarRef write_name_nets_same_as_ports
    syn keyword tclVarRef write_sdc_output_lumped_net_capacitance
    syn keyword tclVarRef write_sdc_output_net_resistance
    syn keyword tclVarRef xt_filter_logic_constant_aggressors
"######################ICC Variables End ########################################

" WIDGETS
" commands associated with widgets
syn keyword tcltkWidgetSwitch contained background highlightbackground insertontime cget
syn keyword tcltkWidgetSwitch contained selectborderwidth borderwidth highlightcolor insertwidth
syn keyword tcltkWidgetSwitch contained selectforeground cursor highlightthickness padx setgrid
syn keyword tcltkWidgetSwitch contained exportselection insertbackground pady takefocus
syn keyword tcltkWidgetSwitch contained font insertborderwidth relief xscrollcommand
syn keyword tcltkWidgetSwitch contained foreground insertofftime selectbackground yscrollcommand
syn keyword tcltkWidgetSwitch contained height spacing1 spacing2 spacing3
syn keyword tcltkWidgetSwitch contained state tabs width wrap
" button
syn keyword tcltkWidgetSwitch contained command default
" canvas
syn keyword tcltkWidgetSwitch contained closeenough confine scrollregion xscrollincrement yscrollincrement orient
" checkbutton, radiobutton
syn keyword tcltkWidgetSwitch contained indicatoron offvalue onvalue selectcolor selectimage state variable
" entry, frame
syn keyword tcltkWidgetSwitch contained show class colormap container visual
" listbox, menu
syn keyword tcltkWidgetSwitch contained selectmode postcommand selectcolor tearoff tearoffcommand title type
" menubutton, message
syn keyword tcltkWidgetSwitch contained direction aspect justify
" scale
syn keyword tcltkWidgetSwitch contained bigincrement digits from length resolution showvalue sliderlength sliderrelief tickinterval to
" scrollbar
syn keyword tcltkWidgetSwitch contained activerelief elementborderwidth
" image
syn keyword tcltkWidgetSwitch contained delete names types create
" variable reference
	" ::optional::namespaces
syn match tclVarRef "$\(\(::\)\?\([[:alnum:]_.]*::\)*\)\a[a-zA-Z0-9_.]*"
	" ${...} may contain any character except '}'
syn match tclVarRef "${[^}]*}"
" menu, mane add
syn keyword tcltkWidgetSwitch contained active end last none cascade checkbutton command radiobutton separator
syn keyword tcltkWidgetSwitch contained activebackground actveforeground accelerator background bitmap columnbreak
syn keyword tcltkWidgetSwitch contained font foreground hidemargin image indicatoron label menu offvalue onvalue
syn keyword tcltkWidgetSwitch contained selectcolor selectimage state underline value variable
syn keyword tcltkWidgetSwitch contained add clone configure delete entrycget entryconfigure index insert invoke
syn keyword tcltkWidgetSwitch contained post postcascade type unpost yposition activate
"syn keyword tcltkWidgetSwitch contained
"syn match tcltkWidgetSwitch contained
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<button\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1 contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<scale\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef

syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<canvas\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<checkbutton\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<entry\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<frame\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<image\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<listbox\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<menubutton\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<message\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<radiobutton\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1 contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\<scrollbar\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
" These words are dual purpose.
" match switches
"syn match tcltkWidgetSwitch contained "-text"hs=s+1
syn match tcltkWidgetSwitch contained "-text\(var\)\?"hs=s+1
syn match tcltkWidgetSwitch contained "-menu"hs=s+1
syn match tcltkWidgetSwitch contained "-label"hs=s+1
" match commands - 2 lines for pretty match.
"variable
" Special case - If a number follows a variable region, it must be at the end of
" the pattern, by definition. Therefore, (1) either include a number as the region
" end and exclude tclNumber from the contains list, or (2) make variable
" keepend. As (1) would put variable out of step with everything else, use (2).
syn region tcltkCommand matchgroup=tcltkCommandColor start="^\<variable\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tclString,tclNumber,tclVarRef,tcltkCommand
syn region tcltkCommand matchgroup=tcltkCommandColor start="\s\<variable\>\|\[\<variable\>"hs=s+1 matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tclString,tclNumber,tclVarRef,tcltkCommand
" menu
syn region tcltkWidget matchgroup=tcltkWidgetColor start="^\<menu\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\s\<menu\>\|\[\<menu\>"hs=s+1 matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
" label
syn region tcltkWidget matchgroup=tcltkWidgetColor start="^\<label\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\s\<label\>\|\[\<label\>"hs=s+1 matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef
" text
syn region tcltkWidget matchgroup=tcltkWidgetColor start="^\<text\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidget,tcltkWidgetSwitch,tcltkSwitch,tclNumber,tclVarRef,tclString
syn region tcltkWidget matchgroup=tcltkWidgetColor start="\s\<text\>\|\[\<text\>"hs=s+1 matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidget,tcltkWidgetSwitch,tclString,tcltkSwitch,tclNumber,tclVarRef

" This isn't contained (I don't think) so it's OK to just associate with the Color group.
" TODO: This could be wrong.
syn keyword tcltkWidgetColor	toplevel


syn region tcltkPackConf matchgroup=tcltkPackConfColor start="\<configure\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tcltkPackConfSwitch,tclNumber,tclVarRef keepend
syn region tcltkPackConf matchgroup=tcltkPackConfColor start="\<cget\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"me=e-1  contains=tclLineContinue,tcltkWidgetSwitch,tclString,tcltkSwitch,tcltkPackConfSwitch,tclNumber,tclVarRef


" NAMESPACE
" commands associated with namespace
syn keyword tcltkNamespaceSwitch contained children code current delete eval
syn keyword tcltkNamespaceSwitch contained export forget import inscope origin
syn keyword tcltkNamespaceSwitch contained parent qualifiers tail which command variable
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<namespace\>" matchgroup=NONE skip="^\s*$" end="{\|}\|]\|\"\|[^\\]*\s*$"me=e-1  contains=tclLineContinue,tcltkNamespaceSwitch

" EXPR
" commands associated with expr
syn keyword tcltkMaths	contained	acos	cos	hypot	sinh
syn keyword tcltkMaths	contained	asin	cosh	log	sqrt
syn keyword tcltkMaths	contained	atan	exp	log10	tan
syn keyword tcltkMaths	contained	atan2	floor	pow	tanh
syn keyword tcltkMaths	contained	ceil	fmod	sin
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<expr\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"me=e-1  contains=tclLineContinue,tcltkMaths,tclNumber,tclVarRef,tclString,tcltlWidgetSwitch,tcltkCommand,tcltkPackConf

" format
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<format\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"me=e-1  contains=tclLineContinue,tcltkMaths,tclNumber,tclVarRef,tclString,tcltlWidgetSwitch,tcltkCommand,tcltkPackConf

" PACK
" commands associated with pack
syn keyword tcltkPackSwitch	contained	forget info propogate slaves
syn keyword tcltkPackConfSwitch	contained	after anchor before expand fill in ipadx ipady padx pady side
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<pack\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkPackSwitch,tcltkPackConf,tcltkPackConfSwitch,tclNumber,tclVarRef,tclString,tcltkCommand keepend

" STRING
" commands associated with string
syn keyword tcltkStringSwitch	contained	compare first index last length match range tolower toupper trim trimleft trimright wordstart wordend
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<string\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkStringSwitch,tclNumber,tclVarRef,tclString,tcltkCommand

" ARRAY
" commands associated with array
syn keyword tcltkArraySwitch	contained	anymore donesearch exists get names nextelement size startsearch set
" match from command name to ] or EOL
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<array\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkArraySwitch,tclNumber,tclVarRef,tclString,tcltkCommand

" LSORT
" switches for lsort
syn keyword tcltkLsortSwitch	contained	ascii dictionary integer real command increasing decreasing index
" match from command name to ] or EOL
syn region tcltkCommand matchgroup=tcltkCommandColor start="\<lsort\>" matchgroup=NONE skip="^\s*$" end="]\|[^\\]*\s*$"he=e-1  contains=tclLineContinue,tcltkLsortSwitch,tclNumber,tclVarRef,tclString,tcltkCommand

syn keyword tclTodo contained	TODO


" String and Character contstants
" Highlight special characters (those which have a backslash) differently
syn match   tclSpecial contained "\\\d\d\d\=\|\\."
" A string needs the skip argument as it may legitimately contain \".
" Match at start of line
syn region  tclString		  start=+^"+ end=+"+ contains=tclSpecial skip=+\\\\\|\\"+
"Match all other legal strings.
syn region  tclString		  start=+[^\\]"+ms=s+1  end=+"+ contains=tclSpecial skip=+\\\\\|\\"+

syn match   tclLineContinue "\\\s*$"

"integer number, or floating point number without a dot and with "f".
syn case ignore
syn match  tclNumber		"\<\d\+\(u\=l\=\|lu\|f\)\>"
"floating point number, with dot, optional exponent
syn match  tclNumber		"\<\d\+\.\d*\(e[-+]\=\d\+\)\=[fl]\=\>"
"floating point number, starting with a dot, optional exponent
syn match  tclNumber		"\.\d\+\(e[-+]\=\d\+\)\=[fl]\=\>"
"floating point number, without dot, with exponent
syn match  tclNumber		"\<\d\+e[-+]\=\d\+[fl]\=\>"
"hex number
syn match  tclNumber		"0x[0-9a-f]\+\(u\=l\=\|lu\)\>"
"syn match  tclIdentifier	"\<[a-z_][a-z0-9_]*\>"
syn case match

syn region  tclComment		start="^\s*\#" skip="\\$" end="$" contains=tclTodo
syn region  tclComment		start=/;\s*\#/hs=s+1 skip="\\$" end="$" contains=tclTodo

"syn sync ccomment tclComment

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_tcl_syntax_inits")
  if version < 508
    let did_tcl_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  HiLink tcltkSwitch		Special
  HiLink tclLabel		Label
  HiLink tclConditional		Conditional
  HiLink tclRepeat		Repeat
  HiLink tclNumber		Number
  HiLink tclError		Error
  HiLink tclStatement		Statement
  "HiLink tclStatementColor	Statement
  HiLink tclString		String
  HiLink tclComment		Comment
  HiLink tclSpecial		Special
  HiLink tclTodo		Todo
  " Below here are the commands and their options.
  HiLink tcltkCommandColor	Statement
  HiLink tcltkWidgetColor	Structure
  HiLink tclLineContinue	WarningMsg
  HiLink tcltkStringSwitch	Special
  HiLink tcltkArraySwitch	Special
  HiLink tcltkLsortSwitch	Special
  HiLink tcltkPackSwitch	Special
  HiLink tcltkPackConfSwitch	Special
  HiLink tcltkMaths		Special
  HiLink tcltkNamespaceSwitch	Special
  HiLink tcltkWidgetSwitch	Special
  HiLink tcltkPackConfColor	Identifier
  "HiLink tcltkLsort		Statement
  HiLink tclVarRef		Identifier

  delcommand HiLink
endif

let b:current_syntax = "tcl"

" vim: ts=8
